/* TileRenderer.c generated by valac 0.44.3, the Vala compiler
 * generated from TileRenderer.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <pango/pango.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <cairo.h>
#include <granite.h>
#include <float.h>
#include <math.h>

#define NOISE_WIDGETS_TYPE_TILE_RENDERER (noise_widgets_tile_renderer_get_type ())
#define NOISE_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer))
#define NOISE_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))
#define NOISE_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))

typedef struct _NoiseWidgetsTileRenderer NoiseWidgetsTileRenderer;
typedef struct _NoiseWidgetsTileRendererClass NoiseWidgetsTileRendererClass;
typedef struct _NoiseWidgetsTileRendererPrivate NoiseWidgetsTileRendererPrivate;
enum  {
	NOISE_WIDGETS_TILE_RENDERER_0_PROPERTY,
	NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY,
	NOISE_WIDGETS_TILE_RENDERER_NUM_PROPERTIES
};
static GParamSpec* noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _NoiseWidgetsTileRenderer {
	GtkCellRenderer parent_instance;
	NoiseWidgetsTileRendererPrivate * priv;
};

struct _NoiseWidgetsTileRendererClass {
	GtkCellRendererClass parent_class;
};

struct _NoiseWidgetsTileRendererPrivate {
	NoiseAlbum* _album;
	PangoLayout* title_text_layout;
	PangoLayout* subtitle_text_layout;
	GtkBorder margin;
	GtkBorder padding;
	GtkBorder border;
	GdkPixbuf* pixbuf;
};

static gint NoiseWidgetsTileRenderer_private_offset;
static gpointer noise_widgets_tile_renderer_parent_class = NULL;

GType noise_widgets_tile_renderer_get_type (void) G_GNUC_CONST;
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_new (void);
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_construct (GType object_type);
static void __lambda53_ (NoiseWidgetsTileRenderer* self);
static void ___lambda53__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void noise_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                                GtkWidget* widget,
                                                GdkRectangle* cell_area,
                                                gint* x_offset,
                                                gint* y_offset,
                                                gint* width,
                                                gint* height);
static GtkSizeRequestMode noise_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base);
static void noise_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                           GtkWidget* widget,
                                                           gint* minimum_size,
                                                           gint* natural_size);
static void noise_widgets_tile_renderer_update_layout_properties (NoiseWidgetsTileRenderer* self,
                                                           GtkWidget* widget);
static gint noise_widgets_tile_renderer_compute_total_image_width (NoiseWidgetsTileRenderer* self);
static void noise_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                      GtkWidget* widget,
                                                                      gint width,
                                                                      gint* minimum_height,
                                                                      gint* natural_height);
static gint noise_widgets_tile_renderer_compute_total_image_height (NoiseWidgetsTileRenderer* self);
static void noise_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                              cairo_t* cr,
                                              GtkWidget* widget,
                                              GdkRectangle* bg_area,
                                              GdkRectangle* cell_area,
                                              GtkCellRendererState flags);
static void noise_widgets_tile_renderer_render_image (NoiseWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint* x,
                                               gint* y,
                                               gint width,
                                               GtkCellRendererState flags);
static void noise_widgets_tile_renderer_render_title (NoiseWidgetsTileRenderer* self,
                                               GtkStyleContext* ctx,
                                               cairo_t* cr,
                                               gint x,
                                               gint* y,
                                               gint width);
static void noise_widgets_tile_renderer_render_subtitle (NoiseWidgetsTileRenderer* self,
                                                  GtkStyleContext* ctx,
                                                  cairo_t* cr,
                                                  gint x,
                                                  gint y,
                                                  gint width);
NoiseAlbum* noise_widgets_tile_renderer_get_album (NoiseWidgetsTileRenderer* self);
void noise_widgets_tile_renderer_set_album (NoiseWidgetsTileRenderer* self,
                                            NoiseAlbum* value);
static void noise_widgets_tile_renderer_finalize (GObject * obj);
static void _vala_noise_widgets_tile_renderer_get_property (GObject * object,
                                                     guint property_id,
                                                     GValue * value,
                                                     GParamSpec * pspec);
static void _vala_noise_widgets_tile_renderer_set_property (GObject * object,
                                                     guint property_id,
                                                     const GValue * value,
                                                     GParamSpec * pspec);

static inline gpointer
noise_widgets_tile_renderer_get_instance_private (NoiseWidgetsTileRenderer* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseWidgetsTileRenderer_private_offset);
}

static void
__lambda53_ (NoiseWidgetsTileRenderer* self)
{
#line 39 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 39 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->pixbuf = NULL;
#line 164 "TileRenderer.c"
}

static void
___lambda53__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 38 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	__lambda53_ ((NoiseWidgetsTileRenderer*) self);
#line 174 "TileRenderer.c"
}

NoiseWidgetsTileRenderer*
noise_widgets_tile_renderer_construct (GType object_type)
{
	NoiseWidgetsTileRenderer * self = NULL;
#line 37 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) g_object_new (object_type, NULL);
#line 38 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_signal_connect_object ((GObject*) self, "notify::album", (GCallback) ___lambda53__g_object_notify, self, 0);
#line 37 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	return self;
#line 187 "TileRenderer.c"
}

NoiseWidgetsTileRenderer*
noise_widgets_tile_renderer_new (void)
{
#line 37 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	return noise_widgets_tile_renderer_construct (NOISE_WIDGETS_TYPE_TILE_RENDERER);
#line 195 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_real_get_size (GtkCellRenderer* base,
                                           GtkWidget* widget,
                                           GdkRectangle* cell_area,
                                           gint* x_offset,
                                           gint* y_offset,
                                           gint* width,
                                           gint* height)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_x_offset = 0;
	gint _vala_y_offset = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 44 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_height = 0;
#line 44 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_width = _vala_height;
#line 44 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_y_offset = _vala_width;
#line 44 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_x_offset = _vala_y_offset;
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (x_offset) {
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*x_offset = _vala_x_offset;
#line 228 "TileRenderer.c"
	}
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (y_offset) {
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*y_offset = _vala_y_offset;
#line 234 "TileRenderer.c"
	}
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (width) {
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*width = _vala_width;
#line 240 "TileRenderer.c"
	}
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (height) {
#line 43 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*height = _vala_height;
#line 246 "TileRenderer.c"
	}
}

static GtkSizeRequestMode
noise_widgets_tile_renderer_real_get_request_mode (GtkCellRenderer* base)
{
	NoiseWidgetsTileRenderer * self;
	GtkSizeRequestMode result = 0;
#line 47 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 48 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 48 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 261 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_real_get_preferred_width (GtkCellRenderer* base,
                                                      GtkWidget* widget,
                                                      gint* minimum_size,
                                                      gint* natural_size)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_minimum_size = 0;
	gint _vala_natural_size = 0;
	gint x_padding = 0;
	gint _tmp0_ = 0;
	gint width = 0;
	GtkBorder _tmp1_;
	GtkBorder _tmp2_;
	GtkBorder _tmp3_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_;
	GtkBorder _tmp6_;
#line 51 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 51 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 52 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
#line 55 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, &_tmp0_, NULL);
#line 55 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	x_padding = _tmp0_;
#line 57 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->margin;
#line 57 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp2_ = self->priv->margin;
#line 57 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = self->priv->padding;
#line 57 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = self->priv->padding;
#line 57 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = self->priv->border;
#line 57 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = self->priv->border;
#line 57 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	width = ((((((noise_widgets_tile_renderer_compute_total_image_width (self) + _tmp1_.left) + _tmp2_.right) + _tmp3_.left) + _tmp4_.right) + _tmp5_.left) + _tmp6_.right) + (2 * x_padding);
#line 63 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_natural_size = width;
#line 63 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_minimum_size = _vala_natural_size;
#line 51 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (minimum_size) {
#line 51 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*minimum_size = _vala_minimum_size;
#line 314 "TileRenderer.c"
	}
#line 51 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (natural_size) {
#line 51 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*natural_size = _vala_natural_size;
#line 320 "TileRenderer.c"
	}
}

static void
noise_widgets_tile_renderer_real_get_preferred_height_for_width (GtkCellRenderer* base,
                                                                 GtkWidget* widget,
                                                                 gint width,
                                                                 gint* minimum_height,
                                                                 gint* natural_height)
{
	NoiseWidgetsTileRenderer * self;
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gint y_padding = 0;
	gint _tmp0_ = 0;
	gint subtitle_height = 0;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
	PangoLayout* _tmp3_;
	gint _tmp4_ = 0;
	gint height = 0;
	GtkBorder _tmp5_;
	GtkBorder _tmp6_;
	GtkBorder _tmp7_;
	GtkBorder _tmp8_;
	GtkBorder _tmp9_;
	GtkBorder _tmp10_;
#line 66 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 66 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 67 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
#line 70 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_cell_renderer_get_padding ((GtkCellRenderer*) self, NULL, &_tmp0_);
#line 70 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	y_padding = _tmp0_;
#line 73 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->title_text_layout;
#line 73 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
#line 73 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	title_height = _tmp2_;
#line 74 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = self->priv->subtitle_text_layout;
#line 74 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_get_pixel_size (_tmp3_, NULL, &_tmp4_);
#line 74 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	subtitle_height = _tmp4_;
#line 76 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = self->priv->margin;
#line 76 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = self->priv->margin;
#line 76 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = self->priv->padding;
#line 76 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = self->priv->padding;
#line 76 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = self->priv->border;
#line 76 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = self->priv->border;
#line 76 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	height = ((((((((noise_widgets_tile_renderer_compute_total_image_height (self) + title_height) + subtitle_height) + _tmp5_.top) + (2 * _tmp6_.bottom)) + _tmp7_.top) + _tmp8_.bottom) + _tmp9_.top) + _tmp10_.bottom) + (2 * y_padding);
#line 83 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_natural_height = height;
#line 83 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_vala_minimum_height = _vala_natural_height;
#line 66 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (minimum_height) {
#line 66 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*minimum_height = _vala_minimum_height;
#line 393 "TileRenderer.c"
	}
#line 66 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (natural_height) {
#line 66 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		*natural_height = _vala_natural_height;
#line 399 "TileRenderer.c"
	}
}

static void
noise_widgets_tile_renderer_real_render (GtkCellRenderer* base,
                                         cairo_t* cr,
                                         GtkWidget* widget,
                                         GdkRectangle* bg_area,
                                         GdkRectangle* cell_area,
                                         GtkCellRendererState flags)
{
	NoiseWidgetsTileRenderer * self;
	GdkRectangle aligned_area = {0};
	GdkRectangle _tmp0_;
	GdkRectangle _tmp1_ = {0};
	gint x = 0;
	GdkRectangle _tmp2_;
	gint y = 0;
	GdkRectangle _tmp3_;
	gint width = 0;
	GdkRectangle _tmp4_;
	gint height = 0;
	GdkRectangle _tmp5_;
	GtkBorder _tmp6_;
	GtkBorder _tmp7_;
	GtkBorder _tmp8_;
	GtkBorder _tmp9_;
	GtkBorder _tmp10_;
	GtkBorder _tmp11_;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp12_;
	GtkBorder _tmp13_;
	GtkBorder _tmp14_;
	GtkBorder _tmp15_;
	GtkBorder _tmp16_;
	GtkBorder _tmp17_;
	GtkBorder _tmp18_;
	GtkBorder _tmp19_;
	GtkBorder _tmp20_;
	GtkBorder _tmp21_;
	GtkBorder _tmp22_;
	GtkBorder _tmp23_;
	GtkBorder _tmp24_;
#line 86 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self = (NoiseWidgetsTileRenderer*) base;
#line 86 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 86 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 86 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (bg_area != NULL);
#line 86 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cell_area != NULL);
#line 87 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_update_layout_properties (self, widget);
#line 89 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = *cell_area;
#line 89 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_cell_renderer_get_aligned_area ((GtkCellRenderer*) self, widget, flags, &_tmp0_, &_tmp1_);
#line 89 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	aligned_area = _tmp1_;
#line 91 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp2_ = aligned_area;
#line 91 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	x = _tmp2_.x;
#line 92 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = aligned_area;
#line 92 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	y = _tmp3_.y;
#line 93 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = aligned_area;
#line 93 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	width = _tmp4_.width;
#line 94 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = aligned_area;
#line 94 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	height = _tmp5_.height;
#line 97 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = self->priv->margin;
#line 97 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = self->priv->border;
#line 97 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = self->priv->padding;
#line 97 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	x = x + ((_tmp6_.left + _tmp7_.left) + _tmp8_.left);
#line 98 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = self->priv->margin;
#line 98 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = self->priv->border;
#line 98 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp11_ = self->priv->padding;
#line 98 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	y = y + ((_tmp9_.top + _tmp10_.top) + _tmp11_.top);
#line 100 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp12_ = gtk_widget_get_style_context (widget);
#line 100 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	ctx = _tmp12_;
#line 102 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp13_ = self->priv->margin;
#line 102 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp14_ = self->priv->margin;
#line 102 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp15_ = self->priv->border;
#line 102 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp16_ = self->priv->border;
#line 102 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp17_ = self->priv->padding;
#line 102 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp18_ = self->priv->padding;
#line 102 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	width = width - (((((_tmp13_.left + _tmp14_.right) + _tmp15_.left) + _tmp16_.right) + _tmp17_.left) + _tmp18_.right);
#line 103 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp19_ = self->priv->margin;
#line 103 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp20_ = self->priv->margin;
#line 103 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp21_ = self->priv->border;
#line 103 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp22_ = self->priv->border;
#line 103 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp23_ = self->priv->padding;
#line 103 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp24_ = self->priv->padding;
#line 103 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	height = height - (((((_tmp19_.top + _tmp20_.bottom) + _tmp21_.top) + _tmp22_.bottom) + _tmp23_.top) + _tmp24_.bottom);
#line 105 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_render_image (self, ctx, cr, &x, &y, width, flags);
#line 106 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_render_title (self, ctx, cr, x, &y, width);
#line 107 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_render_subtitle (self, ctx, cr, x, y, width);
#line 531 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_render_image (NoiseWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint* x,
                                          gint* y,
                                          gint width,
                                          GtkCellRendererState flags)
{
	gint image_width = 0;
	gint image_height = 0;
	GdkPixbuf* _tmp0_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_;
	GtkBorder _tmp6_;
	GtkBorder _tmp7_;
	GtkBorder _tmp8_;
	GtkBorder _tmp9_;
	GtkBorder _tmp10_;
#line 110 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 110 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 111 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	image_width = noise_widgets_tile_renderer_compute_total_image_width (self);
#line 112 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	image_height = noise_widgets_tile_renderer_compute_total_image_height (self);
#line 114 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	*x = (*x) + ((width - image_width) / 2);
#line 116 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (ctx);
#line 117 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (ctx, "album");
#line 118 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (ctx, GRANITE_STYLE_CLASS_CARD);
#line 119 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_background (ctx, cr, (gdouble) (*x), (gdouble) (*y), (gdouble) 128, (gdouble) 128);
#line 121 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->pixbuf;
#line 121 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (_tmp0_ != NULL) {
#line 577 "TileRenderer.c"
		gint scale_factor = 0;
		cairo_surface_t* surface = NULL;
		GdkPixbuf* _tmp1_;
		cairo_surface_t* _tmp2_;
		cairo_surface_t* _tmp3_;
#line 122 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		scale_factor = gtk_style_context_get_scale (ctx);
#line 124 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp1_ = self->priv->pixbuf;
#line 124 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp2_ = gdk_cairo_surface_create_from_pixbuf (_tmp1_, scale_factor, NULL);
#line 124 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		surface = _tmp2_;
#line 126 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp3_ = surface;
#line 126 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		gtk_render_icon_surface (ctx, cr, _tmp3_, (gdouble) (*x), (gdouble) (*y));
#line 121 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		_cairo_surface_destroy0 (surface);
#line 597 "TileRenderer.c"
	}
#line 129 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	cairo_fill_preserve (cr);
#line 130 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = self->priv->border;
#line 130 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp5_ = self->priv->border;
#line 130 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp6_ = self->priv->border;
#line 130 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = self->priv->border;
#line 130 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = self->priv->border;
#line 130 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = self->priv->border;
#line 130 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_frame (ctx, cr, (gdouble) ((*x) - _tmp4_.left), (gdouble) ((*y) - _tmp5_.top), (gdouble) ((128 + _tmp6_.left) + _tmp7_.right), (gdouble) ((128 + _tmp8_.top) + _tmp9_.bottom));
#line 131 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (ctx);
#line 133 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	*y = (*y) + image_height;
#line 136 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = self->priv->margin;
#line 136 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	*x = (*x) + (((image_width - 128) / 2) - _tmp10_.left);
#line 623 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_render_title (NoiseWidgetsTileRenderer* self,
                                          GtkStyleContext* ctx,
                                          cairo_t* cr,
                                          gint x,
                                          gint* y,
                                          gint width)
{
	PangoLayout* _tmp0_;
	gint title_height = 0;
	PangoLayout* _tmp1_;
	gint _tmp2_ = 0;
#line 139 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 139 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 140 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (ctx);
#line 141 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (ctx, "h4");
#line 142 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->title_text_layout;
#line 142 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) (*y), _tmp0_);
#line 143 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (ctx);
#line 146 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->title_text_layout;
#line 146 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_get_pixel_size (_tmp1_, NULL, &_tmp2_);
#line 146 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	title_height = _tmp2_;
#line 148 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	*y = (*y) + title_height;
#line 662 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_render_subtitle (NoiseWidgetsTileRenderer* self,
                                             GtkStyleContext* ctx,
                                             cairo_t* cr,
                                             gint x,
                                             gint y,
                                             gint width)
{
	PangoLayout* _tmp0_;
#line 151 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (ctx != NULL);
#line 151 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (cr != NULL);
#line 152 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->subtitle_text_layout;
#line 152 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_render_layout (ctx, cr, (gdouble) x, (gdouble) y, _tmp0_);
#line 684 "TileRenderer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 156 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	return self ? g_object_ref (self) : NULL;
#line 692 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_update_layout_properties (NoiseWidgetsTileRenderer* self,
                                                      GtkWidget* widget)
{
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStateFlags state = 0U;
	gint scale = 0;
	NoiseAlbum* _tmp2_;
	GdkPixbuf* _tmp3_;
	GtkBorder _tmp4_;
	GtkBorder _tmp5_ = {0};
	GtkBorder _tmp6_ = {0};
	NoiseAlbum* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	PangoLayout* _tmp10_;
	PangoFontDescription* font_description = NULL;
	PangoFontDescription* _tmp11_ = NULL;
	PangoLayout* _tmp12_;
	PangoFontDescription* _tmp13_;
	PangoLayout* _tmp14_;
	PangoLayout* _tmp15_;
	gint text_width = 0;
	PangoLayout* _tmp16_;
	NoiseAlbum* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	PangoLayout* _tmp20_;
	PangoFontDescription* _tmp21_ = NULL;
	PangoLayout* _tmp22_;
	PangoFontDescription* _tmp23_;
	PangoLayout* _tmp24_;
	PangoLayout* _tmp25_;
	PangoLayout* _tmp26_;
#line 155 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (widget != NULL);
#line 156 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = gtk_widget_get_style_context (widget);
#line 156 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 156 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	ctx = _tmp1_;
#line 157 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	state = gtk_style_context_get_state (ctx);
#line 158 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	scale = gtk_style_context_get_scale (ctx);
#line 160 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp2_ = self->priv->_album;
#line 160 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp3_ = noise_album_get_cached_cover_pixbuf (_tmp2_, scale);
#line 160 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 160 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->pixbuf = _tmp3_;
#line 162 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->border.left = (gint16) 12;
#line 163 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->border.right = (gint16) 12;
#line 164 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->border.bottom = (gint16) 12;
#line 165 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->border.top = (gint16) 12;
#line 167 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (ctx);
#line 168 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (ctx, "album");
#line 169 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp4_ = self->priv->border;
#line 169 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->margin = _tmp4_;
#line 170 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get_padding (ctx, state, &_tmp5_);
#line 170 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->padding = _tmp5_;
#line 171 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get_border (ctx, state, &_tmp6_);
#line 171 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->border = _tmp6_;
#line 172 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (ctx);
#line 174 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp7_ = self->priv->_album;
#line 174 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp8_ = noise_album_get_display_artist (_tmp7_);
#line 174 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp9_ = _tmp8_;
#line 174 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp10_ = gtk_widget_create_pango_layout (widget, _tmp9_);
#line 174 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->subtitle_text_layout);
#line 174 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->subtitle_text_layout = _tmp10_;
#line 174 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_free0 (_tmp9_);
#line 176 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get (ctx, state, GTK_STYLE_PROPERTY_FONT, &_tmp11_, NULL);
#line 176 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	font_description = _tmp11_;
#line 177 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp12_ = self->priv->subtitle_text_layout;
#line 177 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp13_ = font_description;
#line 177 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_font_description (_tmp12_, _tmp13_);
#line 178 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp14_ = self->priv->subtitle_text_layout;
#line 178 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_ellipsize (_tmp14_, PANGO_ELLIPSIZE_END);
#line 179 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp15_ = self->priv->subtitle_text_layout;
#line 179 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_alignment (_tmp15_, PANGO_ALIGN_LEFT);
#line 180 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	text_width = 128 * PANGO_SCALE;
#line 181 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp16_ = self->priv->subtitle_text_layout;
#line 181 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_width (_tmp16_, text_width);
#line 183 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_save (ctx);
#line 184 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_add_class (ctx, "h4");
#line 185 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp17_ = self->priv->_album;
#line 185 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp18_ = noise_album_get_display_name (_tmp17_);
#line 185 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp19_ = _tmp18_;
#line 185 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp20_ = gtk_widget_create_pango_layout (widget, _tmp19_);
#line 185 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->title_text_layout);
#line 185 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv->title_text_layout = _tmp20_;
#line 185 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_free0 (_tmp19_);
#line 186 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_get (ctx, state, GTK_STYLE_PROPERTY_FONT, &_tmp21_, NULL);
#line 186 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	font_description = _tmp21_;
#line 187 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp22_ = self->priv->title_text_layout;
#line 187 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp23_ = font_description;
#line 187 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_font_description (_tmp22_, _tmp23_);
#line 188 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp24_ = self->priv->title_text_layout;
#line 188 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_width (_tmp24_, text_width);
#line 189 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp25_ = self->priv->title_text_layout;
#line 189 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_ellipsize (_tmp25_, PANGO_ELLIPSIZE_END);
#line 190 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp26_ = self->priv->title_text_layout;
#line 190 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	pango_layout_set_alignment (_tmp26_, PANGO_ALIGN_LEFT);
#line 191 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	gtk_style_context_restore (ctx);
#line 155 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (ctx);
#line 861 "TileRenderer.c"
}

static gint
noise_widgets_tile_renderer_compute_total_image_width (NoiseWidgetsTileRenderer* self)
{
	gint result = 0;
	GtkBorder _tmp0_;
	GtkBorder _tmp1_;
#line 194 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 195 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->margin;
#line 195 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->margin;
#line 195 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	result = (128 + _tmp0_.left) + _tmp1_.right;
#line 195 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 880 "TileRenderer.c"
}

static gint
noise_widgets_tile_renderer_compute_total_image_height (NoiseWidgetsTileRenderer* self)
{
	gint result = 0;
	GtkBorder _tmp0_;
	GtkBorder _tmp1_;
#line 198 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 199 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->margin;
#line 199 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp1_ = self->priv->margin;
#line 199 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	result = (128 + _tmp0_.top) + _tmp1_.bottom;
#line 199 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 899 "TileRenderer.c"
}

NoiseAlbum*
noise_widgets_tile_renderer_get_album (NoiseWidgetsTileRenderer* self)
{
	NoiseAlbum* result;
	NoiseAlbum* _tmp0_;
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_tmp0_ = self->priv->_album;
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	result = _tmp0_;
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	return result;
#line 915 "TileRenderer.c"
}

void
noise_widgets_tile_renderer_set_album (NoiseWidgetsTileRenderer* self,
                                       NoiseAlbum* value)
{
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	if (noise_widgets_tile_renderer_get_album (self) != value) {
#line 926 "TileRenderer.c"
		NoiseAlbum* _tmp0_;
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		_g_object_unref0 (self->priv->_album);
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		self->priv->_album = _tmp0_;
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY]);
#line 936 "TileRenderer.c"
	}
}

static void
noise_widgets_tile_renderer_class_init (NoiseWidgetsTileRendererClass * klass,
                                        gpointer klass_data)
{
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	noise_widgets_tile_renderer_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_type_class_adjust_private_offset (klass, &NoiseWidgetsTileRenderer_private_offset);
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_size = (void (*) (GtkCellRenderer*, GtkWidget*, GdkRectangle*, gint*, gint*, gint*, gint*)) noise_widgets_tile_renderer_real_get_size;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkCellRenderer*)) noise_widgets_tile_renderer_real_get_request_mode;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_preferred_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint*, gint*)) noise_widgets_tile_renderer_real_get_preferred_width;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->get_preferred_height_for_width = (void (*) (GtkCellRenderer*, GtkWidget*, gint, gint*, gint*)) noise_widgets_tile_renderer_real_get_preferred_height_for_width;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	((GtkCellRendererClass *) klass)->render = (void (*) (GtkCellRenderer*, cairo_t*, GtkWidget*, GdkRectangle*, GdkRectangle*, GtkCellRendererState)) noise_widgets_tile_renderer_real_render;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_widgets_tile_renderer_get_property;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_widgets_tile_renderer_set_property;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_widgets_tile_renderer_finalize;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY, noise_widgets_tile_renderer_properties[NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY] = g_param_spec_object ("album", "album", "album", NOISE_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 966 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_instance_init (NoiseWidgetsTileRenderer * self,
                                           gpointer klass)
{
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self->priv = noise_widgets_tile_renderer_get_instance_private (self);
#line 975 "TileRenderer.c"
}

static void
noise_widgets_tile_renderer_finalize (GObject * obj)
{
	NoiseWidgetsTileRenderer * self;
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
#line 28 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->_album);
#line 30 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->title_text_layout);
#line 31 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->subtitle_text_layout);
#line 35 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	_g_object_unref0 (self->priv->pixbuf);
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	G_OBJECT_CLASS (noise_widgets_tile_renderer_parent_class)->finalize (obj);
#line 994 "TileRenderer.c"
}

GType
noise_widgets_tile_renderer_get_type (void)
{
	static volatile gsize noise_widgets_tile_renderer_type_id__volatile = 0;
	if (g_once_init_enter (&noise_widgets_tile_renderer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseWidgetsTileRendererClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_widgets_tile_renderer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseWidgetsTileRenderer), 0, (GInstanceInitFunc) noise_widgets_tile_renderer_instance_init, NULL };
		GType noise_widgets_tile_renderer_type_id;
		noise_widgets_tile_renderer_type_id = g_type_register_static (gtk_cell_renderer_get_type (), "NoiseWidgetsTileRenderer", &g_define_type_info, 0);
		NoiseWidgetsTileRenderer_private_offset = g_type_add_instance_private (noise_widgets_tile_renderer_type_id, sizeof (NoiseWidgetsTileRendererPrivate));
		g_once_init_leave (&noise_widgets_tile_renderer_type_id__volatile, noise_widgets_tile_renderer_type_id);
	}
	return noise_widgets_tile_renderer_type_id__volatile;
}

static void
_vala_noise_widgets_tile_renderer_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	switch (property_id) {
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		case NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		g_value_set_object (value, noise_widgets_tile_renderer_get_album (self));
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1027 "TileRenderer.c"
		default:
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1033 "TileRenderer.c"
	}
}

static void
_vala_noise_widgets_tile_renderer_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec)
{
	NoiseWidgetsTileRenderer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer);
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
	switch (property_id) {
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		case NOISE_WIDGETS_TILE_RENDERER_ALBUM_PROPERTY:
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		noise_widgets_tile_renderer_set_album (self, g_value_get_object (value));
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1053 "TileRenderer.c"
		default:
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/Widgets/FastView/TileView/TileRenderer.vala"
		break;
#line 1059 "TileRenderer.c"
	}
}

