/* LocalMedia.c generated by valac 0.44.3, the Vala compiler
 * generated from LocalMedia.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.music-core.h"
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <libgda/libgda.h>

#define NOISE_TYPE_LOCAL_MEDIA (noise_local_media_get_type ())
#define NOISE_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia))
#define NOISE_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMediaClass))
#define NOISE_IS_LOCAL_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_LOCAL_MEDIA))
#define NOISE_IS_LOCAL_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_LOCAL_MEDIA))
#define NOISE_LOCAL_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMediaClass))

typedef struct _NoiseLocalMedia NoiseLocalMedia;
typedef struct _NoiseLocalMediaClass NoiseLocalMediaClass;
typedef struct _NoiseLocalMediaPrivate NoiseLocalMediaPrivate;
enum  {
	NOISE_LOCAL_MEDIA_0_PROPERTY,
	NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY,
	NOISE_LOCAL_MEDIA_TITLE_PROPERTY,
	NOISE_LOCAL_MEDIA_TRACK_PROPERTY,
	NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY,
	NOISE_LOCAL_MEDIA_ARTIST_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY,
	NOISE_LOCAL_MEDIA_GROUPING_PROPERTY,
	NOISE_LOCAL_MEDIA_GENRE_PROPERTY,
	NOISE_LOCAL_MEDIA_COMMENT_PROPERTY,
	NOISE_LOCAL_MEDIA_LYRICS_PROPERTY,
	NOISE_LOCAL_MEDIA_YEAR_PROPERTY,
	NOISE_LOCAL_MEDIA_BITRATE_PROPERTY,
	NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY,
	NOISE_LOCAL_MEDIA_LENGTH_PROPERTY,
	NOISE_LOCAL_MEDIA_RATING_PROPERTY,
	NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY,
	NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY,
	NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY,
	NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY,
	NOISE_LOCAL_MEDIA_SHOW_PROPERTY,
	NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY,
	NOISE_LOCAL_MEDIA_NUM_PROPERTIES
};
static GParamSpec* noise_local_media_properties[NOISE_LOCAL_MEDIA_NUM_PROPERTIES];
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseLocalMedia {
	NoiseMedia parent_instance;
	NoiseLocalMediaPrivate * priv;
	guint* _year;
	guint* _bitrate;
	guint* _samplerate;
	guint* _length;
	guint* _play_count;
	guint* _skip_count;
	guint* _date_added;
	guint* _last_played;
	guint* _last_modified;
};

struct _NoiseLocalMediaClass {
	NoiseMediaClass parent_class;
};

struct _NoiseLocalMediaPrivate {
	guint64* _file_size;
	gchar* _title;
	guint* _track;
	guint* _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint* _album_number;
	guint* _album_count;
	NoiseAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint* _show;
	gint _resume_pos;
	GdaConnection* connection;
};

static gint NoiseLocalMedia_private_offset;
static gpointer noise_local_media_parent_class = NULL;

GType noise_local_media_get_type (void) G_GNUC_CONST;
NoiseLocalMedia* noise_local_media_new (gint64 rowid,
                                        GdaConnection* connection);
NoiseLocalMedia* noise_local_media_construct (GType object_type,
                                              gint64 rowid,
                                              GdaConnection* connection);
GValue* noise_database_query_field (gint64 rowid,
                                    GdaConnection* connection,
                                    const gchar* table,
                                    const gchar* field);
#define NOISE_DATABASE_MEDIA_TABLE_NAME "media"
static void _vala_GValue_free (GValue* self);
NoiseLocalMedia* noise_local_media_new_from_media (GdaConnection* connection,
                                                   NoiseMedia* m,
                                                   GError** error);
NoiseLocalMedia* noise_local_media_construct_from_media (GType object_type,
                                                         GdaConnection* connection,
                                                         NoiseMedia* m,
                                                         GError** error);
#define NOISE_DATABASE_MEDIA_ROWID "+26"
static void __vala_GValue_free0_ (gpointer var);
static inline void _g_slist_free___vala_GValue_free0_ (GSList* self);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static guint64 noise_local_media_common_uint64_getter (NoiseLocalMedia* self,
                                                const gchar* field,
                                                guint64** temp);
static guint64* _uint64_dup (guint64* self);
static void noise_local_media_common_uint64_setter (NoiseLocalMedia* self,
                                             const gchar* field,
                                             guint64 value,
                                             guint64** temp);
void noise_database_set_field (gint64 rowid,
                               GdaConnection* connection,
                               const gchar* table,
                               const gchar* field,
                               GValue* value);
static guint noise_local_media_common_uint_getter (NoiseLocalMedia* self,
                                            const gchar* field,
                                            guint** temp);
static guint* _uint_dup (guint* self);
static void noise_local_media_common_uint_setter (NoiseLocalMedia* self,
                                           const gchar* field,
                                           guint value,
                                           guint** temp);
static gchar* noise_local_media_common_string_getter (NoiseLocalMedia* self,
                                               const gchar* field,
                                               gchar* * temp);
static void noise_local_media_common_string_setter (NoiseLocalMedia* self,
                                             const gchar* field,
                                             const gchar* value,
                                             gchar* * temp);
static gboolean _uint_equal (const guint * s1,
                      const guint * s2);
static void noise_local_media_finalize (GObject * obj);
static void _vala_noise_local_media_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_noise_local_media_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);

static inline gpointer
noise_local_media_get_instance_private (NoiseLocalMedia* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseLocalMedia_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 318 "../src/LocalBackend/LocalMedia.vala"
	return self ? g_object_ref (self) : NULL;
#line 204 "LocalMedia.c"
}

static void
_vala_GValue_free (GValue* self)
{
#line 316 "../src/LocalBackend/LocalMedia.vala"
	g_value_unset (self);
#line 316 "../src/LocalBackend/LocalMedia.vala"
	g_free (self);
#line 214 "LocalMedia.c"
}

NoiseLocalMedia*
noise_local_media_construct (GType object_type,
                             gint64 rowid,
                             GdaConnection* connection)
{
	NoiseLocalMedia * self = NULL;
	GdaConnection* _tmp0_;
	GValue* query = NULL;
	GValue* _tmp1_;
	GValue* _tmp2_;
#line 316 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 317 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) g_object_new (object_type, "rowid", rowid, NULL);
#line 318 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = _g_object_ref0 (connection);
#line 318 "../src/LocalBackend/LocalMedia.vala"
	_g_object_unref0 (self->priv->connection);
#line 318 "../src/LocalBackend/LocalMedia.vala"
	self->priv->connection = _tmp0_;
#line 319 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = noise_database_query_field (rowid, connection, NOISE_DATABASE_MEDIA_TABLE_NAME, "uri");
#line 319 "../src/LocalBackend/LocalMedia.vala"
	query = _tmp1_;
#line 320 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = query;
#line 320 "../src/LocalBackend/LocalMedia.vala"
	if (((gpointer) _tmp2_) != NULL) {
#line 245 "LocalMedia.c"
		GValue* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 321 "../src/LocalBackend/LocalMedia.vala"
		_tmp3_ = query;
#line 321 "../src/LocalBackend/LocalMedia.vala"
		_tmp4_ = g_value_dup_string (_tmp3_);
#line 321 "../src/LocalBackend/LocalMedia.vala"
		_tmp5_ = _tmp4_;
#line 321 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_uri ((NoiseMedia*) self, _tmp5_);
#line 321 "../src/LocalBackend/LocalMedia.vala"
		_g_free0 (_tmp5_);
#line 259 "LocalMedia.c"
	}
#line 316 "../src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 316 "../src/LocalBackend/LocalMedia.vala"
	return self;
#line 265 "LocalMedia.c"
}

NoiseLocalMedia*
noise_local_media_new (gint64 rowid,
                       GdaConnection* connection)
{
#line 316 "../src/LocalBackend/LocalMedia.vala"
	return noise_local_media_construct (NOISE_TYPE_LOCAL_MEDIA, rowid, connection);
#line 274 "LocalMedia.c"
}

static void
__vala_GValue_free0_ (gpointer var)
{
#line 390 "../src/LocalBackend/LocalMedia.vala"
	(var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL));
#line 282 "LocalMedia.c"
}

static inline void
_g_slist_free___vala_GValue_free0_ (GSList* self)
{
#line 390 "../src/LocalBackend/LocalMedia.vala"
	g_slist_free_full (self, (GDestroyNotify) __vala_GValue_free0_);
#line 290 "LocalMedia.c"
}

static void
_g_free0_ (gpointer var)
{
#line 390 "../src/LocalBackend/LocalMedia.vala"
	var = (g_free (var), NULL);
#line 298 "LocalMedia.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 390 "../src/LocalBackend/LocalMedia.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 306 "LocalMedia.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 392 "../src/LocalBackend/LocalMedia.vala"
	return self ? g_error_copy (self) : NULL;
#line 314 "LocalMedia.c"
}

NoiseLocalMedia*
noise_local_media_construct_from_media (GType object_type,
                                        GdaConnection* connection,
                                        NoiseMedia* m,
                                        GError** error)
{
	NoiseLocalMedia * self = NULL;
	GValue* query = NULL;
	gint64 _tmp123_;
	gint64 _tmp124_;
	GValue* _tmp125_;
	GValue* _tmp126_;
	GError* _inner_error0_ = NULL;
#line 326 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (connection != NULL, NULL);
#line 326 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (m != NULL, NULL);
#line 334 "LocalMedia.c"
	{
		GdaSqlBuilder* builder = NULL;
		GdaSqlBuilder* _tmp0_;
		GdaSqlBuilder* _tmp1_;
		GdaSqlBuilder* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GValue* _tmp5_ = NULL;
		GdaSet* last_insert_row = NULL;
		GdaStatement* _tmp6_ = NULL;
		GdaSqlBuilder* _tmp7_;
		GdaStatement* _tmp8_;
		GdaSet* _tmp9_ = NULL;
		gint64 _rowid = 0LL;
		GdaSet* _tmp10_;
		GValue _tmp11_;
		GdaConnection* _tmp12_;
		GSList* col_names = NULL;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		GSList* values = NULL;
		guint64 _tmp39_;
		guint64 _tmp40_;
		GValue* _tmp41_ = NULL;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		GValue* _tmp44_ = NULL;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
		GValue* _tmp47_ = NULL;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		GValue* _tmp50_ = NULL;
		const gchar* _tmp51_;
		const gchar* _tmp52_;
		GValue* _tmp53_ = NULL;
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		GValue* _tmp56_ = NULL;
		const gchar* _tmp57_;
		const gchar* _tmp58_;
		GValue* _tmp59_ = NULL;
		const gchar* _tmp60_;
		const gchar* _tmp61_;
		GValue* _tmp62_ = NULL;
		const gchar* _tmp63_;
		const gchar* _tmp64_;
		GValue* _tmp65_ = NULL;
		const gchar* _tmp66_;
		const gchar* _tmp67_;
		GValue* _tmp68_ = NULL;
		gboolean _tmp69_;
		gboolean _tmp70_;
		GValue* _tmp71_ = NULL;
		guint _tmp72_;
		guint _tmp73_;
		GValue* _tmp74_ = NULL;
		guint _tmp75_;
		guint _tmp76_;
		GValue* _tmp77_ = NULL;
		guint _tmp78_;
		guint _tmp79_;
		GValue* _tmp80_ = NULL;
		guint _tmp81_;
		guint _tmp82_;
		GValue* _tmp83_ = NULL;
		guint _tmp84_;
		guint _tmp85_;
		GValue* _tmp86_ = NULL;
		guint _tmp87_;
		guint _tmp88_;
		GValue* _tmp89_ = NULL;
		guint _tmp90_;
		guint _tmp91_;
		GValue* _tmp92_ = NULL;
		guint _tmp93_;
		guint _tmp94_;
		GValue* _tmp95_ = NULL;
		guint _tmp96_;
		guint _tmp97_;
		GValue* _tmp98_ = NULL;
		guint _tmp99_;
		guint _tmp100_;
		GValue* _tmp101_ = NULL;
		guint _tmp102_;
		guint _tmp103_;
		GValue* _tmp104_ = NULL;
		guint _tmp105_;
		guint _tmp106_;
		GValue* _tmp107_ = NULL;
		guint _tmp108_;
		guint _tmp109_;
		GValue* _tmp110_ = NULL;
		guint _tmp111_;
		guint _tmp112_;
		GValue* _tmp113_ = NULL;
		gboolean _tmp114_;
		gboolean _tmp115_;
		GValue* _tmp116_ = NULL;
		GdaSet* _tmp117_;
		GSList* _tmp118_;
		GSList* _tmp119_;
		GValue _tmp120_;
#line 328 "../src/LocalBackend/LocalMedia.vala"
		_tmp0_ = gda_sql_builder_new (GDA_SQL_STATEMENT_INSERT);
#line 328 "../src/LocalBackend/LocalMedia.vala"
		builder = _tmp0_;
#line 329 "../src/LocalBackend/LocalMedia.vala"
		_tmp1_ = builder;
#line 329 "../src/LocalBackend/LocalMedia.vala"
		gda_sql_builder_set_table (_tmp1_, NOISE_DATABASE_MEDIA_TABLE_NAME);
#line 330 "../src/LocalBackend/LocalMedia.vala"
		_tmp2_ = builder;
#line 330 "../src/LocalBackend/LocalMedia.vala"
		_tmp3_ = noise_media_get_uri (m);
#line 330 "../src/LocalBackend/LocalMedia.vala"
		_tmp4_ = _tmp3_;
#line 330 "../src/LocalBackend/LocalMedia.vala"
		_tmp5_ = g_new0 (GValue, 1);
#line 330 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp5_, G_TYPE_STRING);
#line 330 "../src/LocalBackend/LocalMedia.vala"
		g_value_take_string (_tmp5_, _tmp4_);
#line 330 "../src/LocalBackend/LocalMedia.vala"
		gda_sql_builder_add_field_value_as_gvalue (_tmp2_, "uri", _tmp5_);
#line 330 "../src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (_tmp5_);
#line 332 "../src/LocalBackend/LocalMedia.vala"
		_tmp7_ = builder;
#line 332 "../src/LocalBackend/LocalMedia.vala"
		_tmp8_ = gda_sql_builder_get_statement (_tmp7_, &_inner_error0_);
#line 332 "../src/LocalBackend/LocalMedia.vala"
		_tmp6_ = _tmp8_;
#line 332 "../src/LocalBackend/LocalMedia.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (last_insert_row);
#line 332 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (builder);
#line 498 "LocalMedia.c"
			goto __catch66_g_error;
		}
#line 332 "../src/LocalBackend/LocalMedia.vala"
		gda_connection_statement_execute_non_select (connection, _tmp6_, NULL, &_tmp9_, &_inner_error0_);
#line 332 "../src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (last_insert_row);
#line 332 "../src/LocalBackend/LocalMedia.vala"
		last_insert_row = _tmp9_;
#line 332 "../src/LocalBackend/LocalMedia.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 332 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (_tmp6_);
#line 332 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (last_insert_row);
#line 332 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (builder);
#line 515 "LocalMedia.c"
			goto __catch66_g_error;
		}
#line 333 "../src/LocalBackend/LocalMedia.vala"
		_tmp10_ = last_insert_row;
#line 333 "../src/LocalBackend/LocalMedia.vala"
		_tmp11_ = *gda_set_get_holder_value (_tmp10_, NOISE_DATABASE_MEDIA_ROWID);
#line 333 "../src/LocalBackend/LocalMedia.vala"
		_rowid = g_value_get_int64 (&_tmp11_);
#line 334 "../src/LocalBackend/LocalMedia.vala"
		self = (NoiseLocalMedia*) g_object_new (object_type, "rowid", _rowid, NULL);
#line 335 "../src/LocalBackend/LocalMedia.vala"
		_tmp12_ = _g_object_ref0 (connection);
#line 335 "../src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (self->priv->connection);
#line 335 "../src/LocalBackend/LocalMedia.vala"
		self->priv->connection = _tmp12_;
#line 336 "../src/LocalBackend/LocalMedia.vala"
		col_names = NULL;
#line 337 "../src/LocalBackend/LocalMedia.vala"
		_tmp13_ = g_strdup ("file_size");
#line 337 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp13_);
#line 338 "../src/LocalBackend/LocalMedia.vala"
		_tmp14_ = g_strdup ("title");
#line 338 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp14_);
#line 339 "../src/LocalBackend/LocalMedia.vala"
		_tmp15_ = g_strdup ("artist");
#line 339 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp15_);
#line 340 "../src/LocalBackend/LocalMedia.vala"
		_tmp16_ = g_strdup ("composer");
#line 340 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp16_);
#line 341 "../src/LocalBackend/LocalMedia.vala"
		_tmp17_ = g_strdup ("album_artist");
#line 341 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp17_);
#line 342 "../src/LocalBackend/LocalMedia.vala"
		_tmp18_ = g_strdup ("album");
#line 342 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp18_);
#line 343 "../src/LocalBackend/LocalMedia.vala"
		_tmp19_ = g_strdup ("grouping");
#line 343 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp19_);
#line 344 "../src/LocalBackend/LocalMedia.vala"
		_tmp20_ = g_strdup ("genre");
#line 344 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp20_);
#line 345 "../src/LocalBackend/LocalMedia.vala"
		_tmp21_ = g_strdup ("comment");
#line 345 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp21_);
#line 346 "../src/LocalBackend/LocalMedia.vala"
		_tmp22_ = g_strdup ("lyrics");
#line 346 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp22_);
#line 347 "../src/LocalBackend/LocalMedia.vala"
		_tmp23_ = g_strdup ("has_embedded");
#line 347 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp23_);
#line 348 "../src/LocalBackend/LocalMedia.vala"
		_tmp24_ = g_strdup ("year");
#line 348 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp24_);
#line 349 "../src/LocalBackend/LocalMedia.vala"
		_tmp25_ = g_strdup ("track");
#line 349 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp25_);
#line 350 "../src/LocalBackend/LocalMedia.vala"
		_tmp26_ = g_strdup ("track_count");
#line 350 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp26_);
#line 351 "../src/LocalBackend/LocalMedia.vala"
		_tmp27_ = g_strdup ("album_number");
#line 351 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp27_);
#line 352 "../src/LocalBackend/LocalMedia.vala"
		_tmp28_ = g_strdup ("album_count");
#line 352 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp28_);
#line 353 "../src/LocalBackend/LocalMedia.vala"
		_tmp29_ = g_strdup ("bitrate");
#line 353 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp29_);
#line 354 "../src/LocalBackend/LocalMedia.vala"
		_tmp30_ = g_strdup ("length");
#line 354 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp30_);
#line 355 "../src/LocalBackend/LocalMedia.vala"
		_tmp31_ = g_strdup ("samplerate");
#line 355 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp31_);
#line 356 "../src/LocalBackend/LocalMedia.vala"
		_tmp32_ = g_strdup ("rating");
#line 356 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp32_);
#line 357 "../src/LocalBackend/LocalMedia.vala"
		_tmp33_ = g_strdup ("playcount");
#line 357 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp33_);
#line 358 "../src/LocalBackend/LocalMedia.vala"
		_tmp34_ = g_strdup ("skipcount");
#line 358 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp34_);
#line 359 "../src/LocalBackend/LocalMedia.vala"
		_tmp35_ = g_strdup ("dateadded");
#line 359 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp35_);
#line 360 "../src/LocalBackend/LocalMedia.vala"
		_tmp36_ = g_strdup ("lastplayed");
#line 360 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp36_);
#line 361 "../src/LocalBackend/LocalMedia.vala"
		_tmp37_ = g_strdup ("lastmodified");
#line 361 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp37_);
#line 362 "../src/LocalBackend/LocalMedia.vala"
		_tmp38_ = g_strdup ("show");
#line 362 "../src/LocalBackend/LocalMedia.vala"
		col_names = g_slist_append (col_names, _tmp38_);
#line 363 "../src/LocalBackend/LocalMedia.vala"
		values = NULL;
#line 364 "../src/LocalBackend/LocalMedia.vala"
		_tmp39_ = noise_media_get_file_size (m);
#line 364 "../src/LocalBackend/LocalMedia.vala"
		_tmp40_ = _tmp39_;
#line 364 "../src/LocalBackend/LocalMedia.vala"
		_tmp41_ = g_new0 (GValue, 1);
#line 364 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp41_, G_TYPE_UINT64);
#line 364 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint64 (_tmp41_, _tmp40_);
#line 364 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp41_);
#line 365 "../src/LocalBackend/LocalMedia.vala"
		_tmp42_ = noise_media_get_title (m);
#line 365 "../src/LocalBackend/LocalMedia.vala"
		_tmp43_ = _tmp42_;
#line 365 "../src/LocalBackend/LocalMedia.vala"
		_tmp44_ = g_new0 (GValue, 1);
#line 365 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp44_, G_TYPE_STRING);
#line 365 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp44_, _tmp43_);
#line 365 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp44_);
#line 366 "../src/LocalBackend/LocalMedia.vala"
		_tmp45_ = noise_media_get_artist (m);
#line 366 "../src/LocalBackend/LocalMedia.vala"
		_tmp46_ = _tmp45_;
#line 366 "../src/LocalBackend/LocalMedia.vala"
		_tmp47_ = g_new0 (GValue, 1);
#line 366 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp47_, G_TYPE_STRING);
#line 366 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp47_, _tmp46_);
#line 366 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp47_);
#line 367 "../src/LocalBackend/LocalMedia.vala"
		_tmp48_ = noise_media_get_composer (m);
#line 367 "../src/LocalBackend/LocalMedia.vala"
		_tmp49_ = _tmp48_;
#line 367 "../src/LocalBackend/LocalMedia.vala"
		_tmp50_ = g_new0 (GValue, 1);
#line 367 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp50_, G_TYPE_STRING);
#line 367 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp50_, _tmp49_);
#line 367 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp50_);
#line 368 "../src/LocalBackend/LocalMedia.vala"
		_tmp51_ = noise_media_get_album_artist (m);
#line 368 "../src/LocalBackend/LocalMedia.vala"
		_tmp52_ = _tmp51_;
#line 368 "../src/LocalBackend/LocalMedia.vala"
		_tmp53_ = g_new0 (GValue, 1);
#line 368 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp53_, G_TYPE_STRING);
#line 368 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp53_, _tmp52_);
#line 368 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp53_);
#line 369 "../src/LocalBackend/LocalMedia.vala"
		_tmp54_ = noise_media_get_album (m);
#line 369 "../src/LocalBackend/LocalMedia.vala"
		_tmp55_ = _tmp54_;
#line 369 "../src/LocalBackend/LocalMedia.vala"
		_tmp56_ = g_new0 (GValue, 1);
#line 369 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp56_, G_TYPE_STRING);
#line 369 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp56_, _tmp55_);
#line 369 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp56_);
#line 370 "../src/LocalBackend/LocalMedia.vala"
		_tmp57_ = noise_media_get_grouping (m);
#line 370 "../src/LocalBackend/LocalMedia.vala"
		_tmp58_ = _tmp57_;
#line 370 "../src/LocalBackend/LocalMedia.vala"
		_tmp59_ = g_new0 (GValue, 1);
#line 370 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp59_, G_TYPE_STRING);
#line 370 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp59_, _tmp58_);
#line 370 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp59_);
#line 371 "../src/LocalBackend/LocalMedia.vala"
		_tmp60_ = noise_media_get_genre (m);
#line 371 "../src/LocalBackend/LocalMedia.vala"
		_tmp61_ = _tmp60_;
#line 371 "../src/LocalBackend/LocalMedia.vala"
		_tmp62_ = g_new0 (GValue, 1);
#line 371 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp62_, G_TYPE_STRING);
#line 371 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp62_, _tmp61_);
#line 371 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp62_);
#line 372 "../src/LocalBackend/LocalMedia.vala"
		_tmp63_ = noise_media_get_comment (m);
#line 372 "../src/LocalBackend/LocalMedia.vala"
		_tmp64_ = _tmp63_;
#line 372 "../src/LocalBackend/LocalMedia.vala"
		_tmp65_ = g_new0 (GValue, 1);
#line 372 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp65_, G_TYPE_STRING);
#line 372 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp65_, _tmp64_);
#line 372 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp65_);
#line 373 "../src/LocalBackend/LocalMedia.vala"
		_tmp66_ = noise_media_get_lyrics (m);
#line 373 "../src/LocalBackend/LocalMedia.vala"
		_tmp67_ = _tmp66_;
#line 373 "../src/LocalBackend/LocalMedia.vala"
		_tmp68_ = g_new0 (GValue, 1);
#line 373 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp68_, G_TYPE_STRING);
#line 373 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (_tmp68_, _tmp67_);
#line 373 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp68_);
#line 374 "../src/LocalBackend/LocalMedia.vala"
		_tmp69_ = noise_media_get_has_embedded (m);
#line 374 "../src/LocalBackend/LocalMedia.vala"
		_tmp70_ = _tmp69_;
#line 374 "../src/LocalBackend/LocalMedia.vala"
		_tmp71_ = g_new0 (GValue, 1);
#line 374 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp71_, G_TYPE_BOOLEAN);
#line 374 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_boolean (_tmp71_, _tmp70_);
#line 374 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp71_);
#line 375 "../src/LocalBackend/LocalMedia.vala"
		_tmp72_ = noise_media_get_year (m);
#line 375 "../src/LocalBackend/LocalMedia.vala"
		_tmp73_ = _tmp72_;
#line 375 "../src/LocalBackend/LocalMedia.vala"
		_tmp74_ = g_new0 (GValue, 1);
#line 375 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp74_, G_TYPE_UINT);
#line 375 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp74_, _tmp73_);
#line 375 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp74_);
#line 376 "../src/LocalBackend/LocalMedia.vala"
		_tmp75_ = noise_media_get_track (m);
#line 376 "../src/LocalBackend/LocalMedia.vala"
		_tmp76_ = _tmp75_;
#line 376 "../src/LocalBackend/LocalMedia.vala"
		_tmp77_ = g_new0 (GValue, 1);
#line 376 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp77_, G_TYPE_UINT);
#line 376 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp77_, _tmp76_);
#line 376 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp77_);
#line 377 "../src/LocalBackend/LocalMedia.vala"
		_tmp78_ = noise_media_get_track_count (m);
#line 377 "../src/LocalBackend/LocalMedia.vala"
		_tmp79_ = _tmp78_;
#line 377 "../src/LocalBackend/LocalMedia.vala"
		_tmp80_ = g_new0 (GValue, 1);
#line 377 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp80_, G_TYPE_UINT);
#line 377 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp80_, _tmp79_);
#line 377 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp80_);
#line 378 "../src/LocalBackend/LocalMedia.vala"
		_tmp81_ = noise_media_get_album_number (m);
#line 378 "../src/LocalBackend/LocalMedia.vala"
		_tmp82_ = _tmp81_;
#line 378 "../src/LocalBackend/LocalMedia.vala"
		_tmp83_ = g_new0 (GValue, 1);
#line 378 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp83_, G_TYPE_UINT);
#line 378 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp83_, _tmp82_);
#line 378 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp83_);
#line 379 "../src/LocalBackend/LocalMedia.vala"
		_tmp84_ = noise_media_get_album_count (m);
#line 379 "../src/LocalBackend/LocalMedia.vala"
		_tmp85_ = _tmp84_;
#line 379 "../src/LocalBackend/LocalMedia.vala"
		_tmp86_ = g_new0 (GValue, 1);
#line 379 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp86_, G_TYPE_UINT);
#line 379 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp86_, _tmp85_);
#line 379 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp86_);
#line 380 "../src/LocalBackend/LocalMedia.vala"
		_tmp87_ = noise_media_get_bitrate (m);
#line 380 "../src/LocalBackend/LocalMedia.vala"
		_tmp88_ = _tmp87_;
#line 380 "../src/LocalBackend/LocalMedia.vala"
		_tmp89_ = g_new0 (GValue, 1);
#line 380 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp89_, G_TYPE_UINT);
#line 380 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp89_, _tmp88_);
#line 380 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp89_);
#line 381 "../src/LocalBackend/LocalMedia.vala"
		_tmp90_ = noise_media_get_length (m);
#line 381 "../src/LocalBackend/LocalMedia.vala"
		_tmp91_ = _tmp90_;
#line 381 "../src/LocalBackend/LocalMedia.vala"
		_tmp92_ = g_new0 (GValue, 1);
#line 381 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp92_, G_TYPE_UINT);
#line 381 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp92_, _tmp91_);
#line 381 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp92_);
#line 382 "../src/LocalBackend/LocalMedia.vala"
		_tmp93_ = noise_media_get_samplerate (m);
#line 382 "../src/LocalBackend/LocalMedia.vala"
		_tmp94_ = _tmp93_;
#line 382 "../src/LocalBackend/LocalMedia.vala"
		_tmp95_ = g_new0 (GValue, 1);
#line 382 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp95_, G_TYPE_UINT);
#line 382 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp95_, _tmp94_);
#line 382 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp95_);
#line 383 "../src/LocalBackend/LocalMedia.vala"
		_tmp96_ = noise_media_get_rating (m);
#line 383 "../src/LocalBackend/LocalMedia.vala"
		_tmp97_ = _tmp96_;
#line 383 "../src/LocalBackend/LocalMedia.vala"
		_tmp98_ = g_new0 (GValue, 1);
#line 383 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp98_, G_TYPE_UINT);
#line 383 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp98_, _tmp97_);
#line 383 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp98_);
#line 384 "../src/LocalBackend/LocalMedia.vala"
		_tmp99_ = noise_media_get_play_count (m);
#line 384 "../src/LocalBackend/LocalMedia.vala"
		_tmp100_ = _tmp99_;
#line 384 "../src/LocalBackend/LocalMedia.vala"
		_tmp101_ = g_new0 (GValue, 1);
#line 384 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp101_, G_TYPE_UINT);
#line 384 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp101_, _tmp100_);
#line 384 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp101_);
#line 385 "../src/LocalBackend/LocalMedia.vala"
		_tmp102_ = noise_media_get_skip_count (m);
#line 385 "../src/LocalBackend/LocalMedia.vala"
		_tmp103_ = _tmp102_;
#line 385 "../src/LocalBackend/LocalMedia.vala"
		_tmp104_ = g_new0 (GValue, 1);
#line 385 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp104_, G_TYPE_UINT);
#line 385 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp104_, _tmp103_);
#line 385 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp104_);
#line 386 "../src/LocalBackend/LocalMedia.vala"
		_tmp105_ = noise_media_get_date_added (m);
#line 386 "../src/LocalBackend/LocalMedia.vala"
		_tmp106_ = _tmp105_;
#line 386 "../src/LocalBackend/LocalMedia.vala"
		_tmp107_ = g_new0 (GValue, 1);
#line 386 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp107_, G_TYPE_UINT);
#line 386 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp107_, _tmp106_);
#line 386 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp107_);
#line 387 "../src/LocalBackend/LocalMedia.vala"
		_tmp108_ = noise_media_get_last_played (m);
#line 387 "../src/LocalBackend/LocalMedia.vala"
		_tmp109_ = _tmp108_;
#line 387 "../src/LocalBackend/LocalMedia.vala"
		_tmp110_ = g_new0 (GValue, 1);
#line 387 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp110_, G_TYPE_UINT);
#line 387 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp110_, _tmp109_);
#line 387 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp110_);
#line 388 "../src/LocalBackend/LocalMedia.vala"
		_tmp111_ = noise_media_get_last_modified (m);
#line 388 "../src/LocalBackend/LocalMedia.vala"
		_tmp112_ = _tmp111_;
#line 388 "../src/LocalBackend/LocalMedia.vala"
		_tmp113_ = g_new0 (GValue, 1);
#line 388 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp113_, G_TYPE_UINT);
#line 388 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (_tmp113_, _tmp112_);
#line 388 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp113_);
#line 389 "../src/LocalBackend/LocalMedia.vala"
		_tmp114_ = noise_media_get_show (m);
#line 389 "../src/LocalBackend/LocalMedia.vala"
		_tmp115_ = _tmp114_;
#line 389 "../src/LocalBackend/LocalMedia.vala"
		_tmp116_ = g_new0 (GValue, 1);
#line 389 "../src/LocalBackend/LocalMedia.vala"
		g_value_init (_tmp116_, G_TYPE_BOOLEAN);
#line 389 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_boolean (_tmp116_, _tmp115_);
#line 389 "../src/LocalBackend/LocalMedia.vala"
		values = g_slist_append (values, _tmp116_);
#line 390 "../src/LocalBackend/LocalMedia.vala"
		_tmp117_ = last_insert_row;
#line 390 "../src/LocalBackend/LocalMedia.vala"
		_tmp118_ = col_names;
#line 390 "../src/LocalBackend/LocalMedia.vala"
		_tmp119_ = values;
#line 390 "../src/LocalBackend/LocalMedia.vala"
		_tmp120_ = *gda_set_get_holder_value (_tmp117_, NOISE_DATABASE_MEDIA_ROWID);
#line 390 "../src/LocalBackend/LocalMedia.vala"
		gda_connection_update_row_in_table_v (connection, NOISE_DATABASE_MEDIA_TABLE_NAME, "rowid", &_tmp120_, _tmp118_, _tmp119_, &_inner_error0_);
#line 390 "../src/LocalBackend/LocalMedia.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 390 "../src/LocalBackend/LocalMedia.vala"
			(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 390 "../src/LocalBackend/LocalMedia.vala"
			(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 390 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (_tmp6_);
#line 390 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (last_insert_row);
#line 390 "../src/LocalBackend/LocalMedia.vala"
			_g_object_unref0 (builder);
#line 974 "LocalMedia.c"
			goto __catch66_g_error;
		}
#line 327 "../src/LocalBackend/LocalMedia.vala"
		(values == NULL) ? NULL : (values = (_g_slist_free___vala_GValue_free0_ (values), NULL));
#line 327 "../src/LocalBackend/LocalMedia.vala"
		(col_names == NULL) ? NULL : (col_names = (_g_slist_free__g_free0_ (col_names), NULL));
#line 327 "../src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (_tmp6_);
#line 327 "../src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (last_insert_row);
#line 327 "../src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (builder);
#line 987 "LocalMedia.c"
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* e = NULL;
		GError* _tmp121_;
		GError* _tmp122_;
#line 327 "../src/LocalBackend/LocalMedia.vala"
		e = _inner_error0_;
#line 327 "../src/LocalBackend/LocalMedia.vala"
		_inner_error0_ = NULL;
#line 392 "../src/LocalBackend/LocalMedia.vala"
		_tmp121_ = e;
#line 392 "../src/LocalBackend/LocalMedia.vala"
		_tmp122_ = _g_error_copy0 (_tmp121_);
#line 392 "../src/LocalBackend/LocalMedia.vala"
		_inner_error0_ = _tmp122_;
#line 392 "../src/LocalBackend/LocalMedia.vala"
		_g_error_free0 (e);
#line 1007 "LocalMedia.c"
		goto __finally66;
	}
	__finally66:
#line 327 "../src/LocalBackend/LocalMedia.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 327 "../src/LocalBackend/LocalMedia.vala"
		g_propagate_error (error, _inner_error0_);
#line 327 "../src/LocalBackend/LocalMedia.vala"
		_g_object_unref0 (self);
#line 327 "../src/LocalBackend/LocalMedia.vala"
		return NULL;
#line 1019 "LocalMedia.c"
	}
#line 395 "../src/LocalBackend/LocalMedia.vala"
	_tmp123_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 395 "../src/LocalBackend/LocalMedia.vala"
	_tmp124_ = _tmp123_;
#line 395 "../src/LocalBackend/LocalMedia.vala"
	_tmp125_ = noise_database_query_field (_tmp124_, connection, NOISE_DATABASE_MEDIA_TABLE_NAME, "uri");
#line 395 "../src/LocalBackend/LocalMedia.vala"
	query = _tmp125_;
#line 396 "../src/LocalBackend/LocalMedia.vala"
	_tmp126_ = query;
#line 396 "../src/LocalBackend/LocalMedia.vala"
	if (((gpointer) _tmp126_) != NULL) {
#line 1033 "LocalMedia.c"
		GValue* _tmp127_;
		gchar* _tmp128_;
		gchar* _tmp129_;
#line 397 "../src/LocalBackend/LocalMedia.vala"
		_tmp127_ = query;
#line 397 "../src/LocalBackend/LocalMedia.vala"
		_tmp128_ = g_value_dup_string (_tmp127_);
#line 397 "../src/LocalBackend/LocalMedia.vala"
		_tmp129_ = _tmp128_;
#line 397 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_uri ((NoiseMedia*) self, _tmp129_);
#line 397 "../src/LocalBackend/LocalMedia.vala"
		_g_free0 (_tmp129_);
#line 1047 "LocalMedia.c"
	}
#line 326 "../src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 326 "../src/LocalBackend/LocalMedia.vala"
	return self;
#line 1053 "LocalMedia.c"
}

NoiseLocalMedia*
noise_local_media_new_from_media (GdaConnection* connection,
                                  NoiseMedia* m,
                                  GError** error)
{
#line 326 "../src/LocalBackend/LocalMedia.vala"
	return noise_local_media_construct_from_media (NOISE_TYPE_LOCAL_MEDIA, connection, m, error);
#line 1063 "LocalMedia.c"
}

static guint64*
_uint64_dup (guint64* self)
{
	guint64* dup;
#line 410 "../src/LocalBackend/LocalMedia.vala"
	dup = g_new0 (guint64, 1);
#line 410 "../src/LocalBackend/LocalMedia.vala"
	memcpy (dup, self, sizeof (guint64));
#line 410 "../src/LocalBackend/LocalMedia.vala"
	return dup;
#line 1076 "LocalMedia.c"
}

static gpointer
__uint64_dup0 (gpointer self)
{
#line 410 "../src/LocalBackend/LocalMedia.vala"
	return self ? _uint64_dup (self) : NULL;
#line 1084 "LocalMedia.c"
}

static guint64
noise_local_media_common_uint64_getter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        guint64** temp)
{
	guint64 result = 0ULL;
	GValue* query = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
#line 404 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 404 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (field != NULL, 0ULL);
#line 405 "../src/LocalBackend/LocalMedia.vala"
	if ((*temp) != NULL) {
#line 406 "../src/LocalBackend/LocalMedia.vala"
		result = *(*temp);
#line 406 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1109 "LocalMedia.c"
	}
#line 408 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 408 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 408 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->connection;
#line 408 "../src/LocalBackend/LocalMedia.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_MEDIA_TABLE_NAME, field);
#line 408 "../src/LocalBackend/LocalMedia.vala"
	query = _tmp3_;
#line 409 "../src/LocalBackend/LocalMedia.vala"
	_tmp4_ = query;
#line 409 "../src/LocalBackend/LocalMedia.vala"
	if (((gpointer) _tmp4_) != NULL) {
#line 1125 "LocalMedia.c"
		GValue* _tmp5_;
		guint64 _tmp6_;
		guint64* _tmp7_;
#line 410 "../src/LocalBackend/LocalMedia.vala"
		_tmp5_ = query;
#line 410 "../src/LocalBackend/LocalMedia.vala"
		_tmp6_ = (guint64) g_value_get_int (_tmp5_);
#line 410 "../src/LocalBackend/LocalMedia.vala"
		_tmp7_ = __uint64_dup0 (&_tmp6_);
#line 410 "../src/LocalBackend/LocalMedia.vala"
		_g_free0 (*temp);
#line 410 "../src/LocalBackend/LocalMedia.vala"
		*temp = _tmp7_;
#line 411 "../src/LocalBackend/LocalMedia.vala"
		result = *(*temp);
#line 411 "../src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 411 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1145 "LocalMedia.c"
	} else {
#line 413 "../src/LocalBackend/LocalMedia.vala"
		result = (guint64) 0;
#line 413 "../src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 413 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1153 "LocalMedia.c"
	}
#line 404 "../src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 1157 "LocalMedia.c"
}

static void
noise_local_media_common_uint64_setter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        guint64 value,
                                        guint64** temp)
{
	guint64* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
#line 416 "../src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (self != NULL);
#line 416 "../src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (field != NULL);
#line 417 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = __uint64_dup0 (&value);
#line 417 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (*temp);
#line 417 "../src/LocalBackend/LocalMedia.vala"
	*temp = _tmp0_;
#line 418 "../src/LocalBackend/LocalMedia.vala"
	g_value_init (&_tmp1_, G_TYPE_UINT64);
#line 418 "../src/LocalBackend/LocalMedia.vala"
	val = _tmp1_;
#line 419 "../src/LocalBackend/LocalMedia.vala"
	g_value_set_uint64 (&val, value);
#line 420 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 420 "../src/LocalBackend/LocalMedia.vala"
	_tmp3_ = _tmp2_;
#line 420 "../src/LocalBackend/LocalMedia.vala"
	_tmp4_ = self->priv->connection;
#line 420 "../src/LocalBackend/LocalMedia.vala"
	_tmp5_ = val;
#line 420 "../src/LocalBackend/LocalMedia.vala"
	noise_database_set_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
#line 416 "../src/LocalBackend/LocalMedia.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 1201 "LocalMedia.c"
}

static guint*
_uint_dup (guint* self)
{
	guint* dup;
#line 429 "../src/LocalBackend/LocalMedia.vala"
	dup = g_new0 (guint, 1);
#line 429 "../src/LocalBackend/LocalMedia.vala"
	memcpy (dup, self, sizeof (guint));
#line 429 "../src/LocalBackend/LocalMedia.vala"
	return dup;
#line 1214 "LocalMedia.c"
}

static gpointer
__uint_dup0 (gpointer self)
{
#line 429 "../src/LocalBackend/LocalMedia.vala"
	return self ? _uint_dup (self) : NULL;
#line 1222 "LocalMedia.c"
}

static guint
noise_local_media_common_uint_getter (NoiseLocalMedia* self,
                                      const gchar* field,
                                      guint** temp)
{
	guint result = 0U;
	GValue* query = NULL;
	gint64 _tmp0_;
	gint64 _tmp1_;
	GdaConnection* _tmp2_;
	GValue* _tmp3_;
	GValue* _tmp4_;
#line 423 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 423 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (field != NULL, 0U);
#line 424 "../src/LocalBackend/LocalMedia.vala"
	if ((*temp) != NULL) {
#line 425 "../src/LocalBackend/LocalMedia.vala"
		result = *(*temp);
#line 425 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1247 "LocalMedia.c"
	}
#line 427 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 427 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 427 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->connection;
#line 427 "../src/LocalBackend/LocalMedia.vala"
	_tmp3_ = noise_database_query_field (_tmp1_, _tmp2_, NOISE_DATABASE_MEDIA_TABLE_NAME, field);
#line 427 "../src/LocalBackend/LocalMedia.vala"
	query = _tmp3_;
#line 428 "../src/LocalBackend/LocalMedia.vala"
	_tmp4_ = query;
#line 428 "../src/LocalBackend/LocalMedia.vala"
	if (((gpointer) _tmp4_) != NULL) {
#line 1263 "LocalMedia.c"
		GValue* _tmp5_;
		guint _tmp6_;
		guint* _tmp7_;
#line 429 "../src/LocalBackend/LocalMedia.vala"
		_tmp5_ = query;
#line 429 "../src/LocalBackend/LocalMedia.vala"
		_tmp6_ = (guint) g_value_get_int (_tmp5_);
#line 429 "../src/LocalBackend/LocalMedia.vala"
		_tmp7_ = __uint_dup0 (&_tmp6_);
#line 429 "../src/LocalBackend/LocalMedia.vala"
		_g_free0 (*temp);
#line 429 "../src/LocalBackend/LocalMedia.vala"
		*temp = _tmp7_;
#line 430 "../src/LocalBackend/LocalMedia.vala"
		result = *(*temp);
#line 430 "../src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 430 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1283 "LocalMedia.c"
	} else {
#line 432 "../src/LocalBackend/LocalMedia.vala"
		result = (guint) 0;
#line 432 "../src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 432 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1291 "LocalMedia.c"
	}
#line 423 "../src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 1295 "LocalMedia.c"
}

static void
noise_local_media_common_uint_setter (NoiseLocalMedia* self,
                                      const gchar* field,
                                      guint value,
                                      guint** temp)
{
	guint* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
#line 435 "../src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (self != NULL);
#line 435 "../src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (field != NULL);
#line 436 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = __uint_dup0 (&value);
#line 436 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (*temp);
#line 436 "../src/LocalBackend/LocalMedia.vala"
	*temp = _tmp0_;
#line 437 "../src/LocalBackend/LocalMedia.vala"
	g_value_init (&_tmp1_, G_TYPE_UINT);
#line 437 "../src/LocalBackend/LocalMedia.vala"
	val = _tmp1_;
#line 438 "../src/LocalBackend/LocalMedia.vala"
	g_value_set_uint (&val, value);
#line 439 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 439 "../src/LocalBackend/LocalMedia.vala"
	_tmp3_ = _tmp2_;
#line 439 "../src/LocalBackend/LocalMedia.vala"
	_tmp4_ = self->priv->connection;
#line 439 "../src/LocalBackend/LocalMedia.vala"
	_tmp5_ = val;
#line 439 "../src/LocalBackend/LocalMedia.vala"
	noise_database_set_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
#line 435 "../src/LocalBackend/LocalMedia.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 1339 "LocalMedia.c"
}

static gchar*
noise_local_media_common_string_getter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        gchar* * temp)
{
	gchar* result = NULL;
	GValue* query = NULL;
	gint64 _tmp1_;
	gint64 _tmp2_;
	GdaConnection* _tmp3_;
	GValue* _tmp4_;
	GValue* _tmp5_;
#line 442 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 442 "../src/LocalBackend/LocalMedia.vala"
	g_return_val_if_fail (field != NULL, NULL);
#line 443 "../src/LocalBackend/LocalMedia.vala"
	if ((*temp) != NULL) {
#line 1360 "LocalMedia.c"
		gchar* _tmp0_;
#line 444 "../src/LocalBackend/LocalMedia.vala"
		_tmp0_ = g_strdup (*temp);
#line 444 "../src/LocalBackend/LocalMedia.vala"
		result = _tmp0_;
#line 444 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1368 "LocalMedia.c"
	}
#line 446 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 446 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = _tmp1_;
#line 446 "../src/LocalBackend/LocalMedia.vala"
	_tmp3_ = self->priv->connection;
#line 446 "../src/LocalBackend/LocalMedia.vala"
	_tmp4_ = noise_database_query_field (_tmp2_, _tmp3_, NOISE_DATABASE_MEDIA_TABLE_NAME, field);
#line 446 "../src/LocalBackend/LocalMedia.vala"
	query = _tmp4_;
#line 447 "../src/LocalBackend/LocalMedia.vala"
	_tmp5_ = query;
#line 447 "../src/LocalBackend/LocalMedia.vala"
	if (((gpointer) _tmp5_) != NULL) {
#line 1384 "LocalMedia.c"
		GValue* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
#line 448 "../src/LocalBackend/LocalMedia.vala"
		_tmp6_ = query;
#line 448 "../src/LocalBackend/LocalMedia.vala"
		_tmp7_ = g_value_dup_string (_tmp6_);
#line 448 "../src/LocalBackend/LocalMedia.vala"
		_g_free0 (*temp);
#line 448 "../src/LocalBackend/LocalMedia.vala"
		*temp = _tmp7_;
#line 449 "../src/LocalBackend/LocalMedia.vala"
		_tmp8_ = self->priv->_composer;
#line 449 "../src/LocalBackend/LocalMedia.vala"
		_tmp9_ = g_strdup (_tmp8_);
#line 449 "../src/LocalBackend/LocalMedia.vala"
		result = _tmp9_;
#line 449 "../src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 449 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1407 "LocalMedia.c"
	} else {
		const gchar* _tmp10_;
		gchar* _tmp11_;
#line 451 "../src/LocalBackend/LocalMedia.vala"
		_tmp10_ = noise_media_UNKNOWN;
#line 451 "../src/LocalBackend/LocalMedia.vala"
		_tmp11_ = g_strdup (_tmp10_);
#line 451 "../src/LocalBackend/LocalMedia.vala"
		result = _tmp11_;
#line 451 "../src/LocalBackend/LocalMedia.vala"
		__vala_GValue_free0 (query);
#line 451 "../src/LocalBackend/LocalMedia.vala"
		return result;
#line 1421 "LocalMedia.c"
	}
#line 442 "../src/LocalBackend/LocalMedia.vala"
	__vala_GValue_free0 (query);
#line 1425 "LocalMedia.c"
}

static void
noise_local_media_common_string_setter (NoiseLocalMedia* self,
                                        const gchar* field,
                                        const gchar* value,
                                        gchar* * temp)
{
	gchar* _tmp0_;
	GValue val = {0};
	GValue _tmp1_ = {0};
	gint64 _tmp2_;
	gint64 _tmp3_;
	GdaConnection* _tmp4_;
	GValue _tmp5_;
#line 454 "../src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (self != NULL);
#line 454 "../src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (field != NULL);
#line 454 "../src/LocalBackend/LocalMedia.vala"
	g_return_if_fail (value != NULL);
#line 455 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = g_strdup (value);
#line 455 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (*temp);
#line 455 "../src/LocalBackend/LocalMedia.vala"
	*temp = _tmp0_;
#line 456 "../src/LocalBackend/LocalMedia.vala"
	g_value_init (&_tmp1_, G_TYPE_STRING);
#line 456 "../src/LocalBackend/LocalMedia.vala"
	val = _tmp1_;
#line 457 "../src/LocalBackend/LocalMedia.vala"
	g_value_set_string (&val, value);
#line 458 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = noise_media_get_rowid ((NoiseMedia*) self);
#line 458 "../src/LocalBackend/LocalMedia.vala"
	_tmp3_ = _tmp2_;
#line 458 "../src/LocalBackend/LocalMedia.vala"
	_tmp4_ = self->priv->connection;
#line 458 "../src/LocalBackend/LocalMedia.vala"
	_tmp5_ = val;
#line 458 "../src/LocalBackend/LocalMedia.vala"
	noise_database_set_field (_tmp3_, _tmp4_, NOISE_DATABASE_MEDIA_TABLE_NAME, field, &_tmp5_);
#line 454 "../src/LocalBackend/LocalMedia.vala"
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
#line 1471 "LocalMedia.c"
}

static guint64
noise_local_media_real_get_file_size (NoiseMedia* base)
{
	guint64 result;
	NoiseLocalMedia* self;
	guint64* _tmp0_;
#line 32 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 33 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint64_getter (self, "file_size", &self->priv->_file_size);
#line 34 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_file_size;
#line 34 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 34 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1490 "LocalMedia.c"
}

static void
noise_local_media_real_set_file_size (NoiseMedia* base,
                                      guint64 value)
{
	NoiseLocalMedia* self;
#line 36 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 37 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint64_setter (self, "file_size", value, &self->priv->_file_size);
#line 36 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY]);
#line 1504 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_title (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 46 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 47 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "title", &self->priv->_title);
#line 47 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 48 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_title;
#line 48 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 48 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1529 "LocalMedia.c"
}

static void
noise_local_media_real_set_title (NoiseMedia* base,
                                  const gchar* value)
{
	NoiseLocalMedia* self;
#line 50 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 51 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "title", value, &self->priv->_title);
#line 50 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TITLE_PROPERTY]);
#line 1543 "LocalMedia.c"
}

static guint
noise_local_media_real_get_track (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 57 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 58 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "track", &self->priv->_track);
#line 59 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_track;
#line 59 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 59 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1562 "LocalMedia.c"
}

static void
noise_local_media_real_set_track (NoiseMedia* base,
                                  guint value)
{
	NoiseLocalMedia* self;
#line 61 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 62 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "track", value, &self->priv->_track);
#line 61 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_PROPERTY]);
#line 1576 "LocalMedia.c"
}

static guint
noise_local_media_real_get_track_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 68 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 69 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "track_count", &self->priv->_track_count);
#line 70 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_track_count;
#line 70 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 70 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1595 "LocalMedia.c"
}

static void
noise_local_media_real_set_track_count (NoiseMedia* base,
                                        guint value)
{
	NoiseLocalMedia* self;
#line 72 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 73 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "track_count", value, &self->priv->_track_count);
#line 72 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY]);
#line 1609 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_composer (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 79 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 80 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "composer", &self->priv->_composer);
#line 80 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 80 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 81 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_composer;
#line 81 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 81 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1634 "LocalMedia.c"
}

static void
noise_local_media_real_set_composer (NoiseMedia* base,
                                     const gchar* value)
{
	NoiseLocalMedia* self;
#line 83 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 84 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "composer", value, &self->priv->_composer);
#line 83 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY]);
#line 1648 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 90 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 91 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "artist", &self->priv->_artist);
#line 91 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 91 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 92 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_artist;
#line 92 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 92 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1673 "LocalMedia.c"
}

static void
noise_local_media_real_set_artist (NoiseMedia* base,
                                   const gchar* value)
{
	NoiseLocalMedia* self;
#line 94 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 95 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "artist", value, &self->priv->_artist);
#line 94 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ARTIST_PROPERTY]);
#line 1687 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_album_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 101 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 102 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "album_artist", &self->priv->_album_artist);
#line 102 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 102 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 103 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_album_artist;
#line 103 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 103 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1712 "LocalMedia.c"
}

static void
noise_local_media_real_set_album_artist (NoiseMedia* base,
                                         const gchar* value)
{
	NoiseLocalMedia* self;
#line 105 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 106 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "album_artist", value, &self->priv->_album_artist);
#line 105 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY]);
#line 1726 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_album (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 112 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 113 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "album", &self->priv->_album);
#line 113 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 113 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 114 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_album;
#line 114 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 114 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1751 "LocalMedia.c"
}

static void
noise_local_media_real_set_album (NoiseMedia* base,
                                  const gchar* value)
{
	NoiseLocalMedia* self;
#line 116 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 117 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "album", value, &self->priv->_album);
#line 116 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_PROPERTY]);
#line 1765 "LocalMedia.c"
}

static guint
noise_local_media_real_get_album_number (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 123 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 124 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "album_number", &self->priv->_album_number);
#line 125 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_album_number;
#line 125 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 125 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1784 "LocalMedia.c"
}

static void
noise_local_media_real_set_album_number (NoiseMedia* base,
                                         guint value)
{
	NoiseLocalMedia* self;
#line 127 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 128 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "album_number", value, &self->priv->_album_number);
#line 127 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY]);
#line 1798 "LocalMedia.c"
}

static guint
noise_local_media_real_get_album_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 134 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 135 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "album_count", &self->priv->_album_count);
#line 136 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_album_count;
#line 136 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 136 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1817 "LocalMedia.c"
}

static void
noise_local_media_real_set_album_count (NoiseMedia* base,
                                        guint value)
{
	NoiseLocalMedia* self;
#line 138 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 139 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "album_count", value, &self->priv->_album_count);
#line 138 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY]);
#line 1831 "LocalMedia.c"
}

static NoiseAlbum*
noise_local_media_real_get_album_info (NoiseMedia* base)
{
	NoiseAlbum* result;
	NoiseLocalMedia* self;
	NoiseAlbum* _tmp0_;
#line 143 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 143 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_album_info;
#line 143 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp0_;
#line 143 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1848 "LocalMedia.c"
}

static void
noise_local_media_real_set_album_info (NoiseMedia* base,
                                       NoiseAlbum* value)
{
	NoiseLocalMedia* self;
#line 143 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 143 "../src/LocalBackend/LocalMedia.vala"
	if (noise_local_media_real_get_album_info (base) != value) {
#line 143 "../src/LocalBackend/LocalMedia.vala"
		self->priv->_album_info = value;
#line 143 "../src/LocalBackend/LocalMedia.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY]);
#line 1864 "LocalMedia.c"
	}
}

static const gchar*
noise_local_media_real_get_grouping (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 146 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 147 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "grouping", &self->priv->_grouping);
#line 147 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 147 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 148 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_grouping;
#line 148 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 148 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1890 "LocalMedia.c"
}

static void
noise_local_media_real_set_grouping (NoiseMedia* base,
                                     const gchar* value)
{
	NoiseLocalMedia* self;
#line 150 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 151 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "grouping", value, &self->priv->_grouping);
#line 150 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_GROUPING_PROPERTY]);
#line 1904 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_genre (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 157 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 158 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "genre", &self->priv->_genre);
#line 158 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 158 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 159 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_genre;
#line 159 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 159 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1929 "LocalMedia.c"
}

static void
noise_local_media_real_set_genre (NoiseMedia* base,
                                  const gchar* value)
{
	NoiseLocalMedia* self;
#line 161 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 162 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "genre", value, &self->priv->_genre);
#line 161 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_GENRE_PROPERTY]);
#line 1943 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_comment (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 168 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 169 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "comment", &self->priv->_comment);
#line 169 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 169 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 170 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_comment;
#line 170 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 170 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 1968 "LocalMedia.c"
}

static void
noise_local_media_real_set_comment (NoiseMedia* base,
                                    const gchar* value)
{
	NoiseLocalMedia* self;
#line 172 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 173 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "comment", value, &self->priv->_comment);
#line 172 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMMENT_PROPERTY]);
#line 1982 "LocalMedia.c"
}

static const gchar*
noise_local_media_real_get_lyrics (NoiseMedia* base)
{
	const gchar* result;
	NoiseLocalMedia* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 179 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 180 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = noise_local_media_common_string_getter (self, "lyrics", &self->priv->_lyrics);
#line 180 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = _tmp0_;
#line 180 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (_tmp1_);
#line 181 "../src/LocalBackend/LocalMedia.vala"
	_tmp2_ = self->priv->_lyrics;
#line 181 "../src/LocalBackend/LocalMedia.vala"
	result = _tmp2_;
#line 181 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2007 "LocalMedia.c"
}

static void
noise_local_media_real_set_lyrics (NoiseMedia* base,
                                   const gchar* value)
{
	NoiseLocalMedia* self;
#line 183 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 184 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_string_setter (self, "lyrics", value, &self->priv->_lyrics);
#line 183 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LYRICS_PROPERTY]);
#line 2021 "LocalMedia.c"
}

static guint
noise_local_media_real_get_year (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 190 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 191 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "year", &self->_year);
#line 192 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_year;
#line 192 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 192 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2040 "LocalMedia.c"
}

static void
noise_local_media_real_set_year (NoiseMedia* base,
                                 guint value)
{
	NoiseLocalMedia* self;
#line 194 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 195 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "year", value, &self->_year);
#line 194 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_YEAR_PROPERTY]);
#line 2054 "LocalMedia.c"
}

static guint
noise_local_media_real_get_bitrate (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 201 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 202 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "bitrate", &self->_bitrate);
#line 203 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_bitrate;
#line 203 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 203 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2073 "LocalMedia.c"
}

static void
noise_local_media_real_set_bitrate (NoiseMedia* base,
                                    guint value)
{
	NoiseLocalMedia* self;
#line 205 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 206 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "bitrate", value, &self->_bitrate);
#line 205 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_BITRATE_PROPERTY]);
#line 2087 "LocalMedia.c"
}

static guint
noise_local_media_real_get_samplerate (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 212 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 213 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "samplerate", &self->_samplerate);
#line 214 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_samplerate;
#line 214 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 214 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2106 "LocalMedia.c"
}

static void
noise_local_media_real_set_samplerate (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
#line 216 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 217 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "samplerate", value, &self->_samplerate);
#line 216 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY]);
#line 2120 "LocalMedia.c"
}

static guint
noise_local_media_real_get_length (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 223 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 224 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "length", &self->_length);
#line 225 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_length;
#line 225 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 225 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2139 "LocalMedia.c"
}

static void
noise_local_media_real_set_length (NoiseMedia* base,
                                   guint value)
{
	NoiseLocalMedia* self;
#line 227 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 228 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "length", value, &self->_length);
#line 227 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LENGTH_PROPERTY]);
#line 2153 "LocalMedia.c"
}

static guint
noise_local_media_real_get_rating (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
#line 233 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 234 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "rating", &((NoiseMedia*) self)->_rating);
#line 235 "../src/LocalBackend/LocalMedia.vala"
	result = ((NoiseMedia*) self)->_rating;
#line 235 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2169 "LocalMedia.c"
}

static void
noise_local_media_real_set_rating (NoiseMedia* base,
                                   guint value)
{
	NoiseLocalMedia* self;
#line 237 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 238 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "rating", CLAMP (value, (guint) 0, (guint) 5), &((NoiseMedia*) self)->_rating);
#line 237 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_RATING_PROPERTY]);
#line 2183 "LocalMedia.c"
}

static guint
noise_local_media_real_get_play_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 247 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 248 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "playcount", &self->_play_count);
#line 249 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_play_count;
#line 249 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 249 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2202 "LocalMedia.c"
}

static void
noise_local_media_real_set_play_count (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
#line 251 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 252 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "playcount", value, &self->_play_count);
#line 251 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY]);
#line 2216 "LocalMedia.c"
}

static guint
noise_local_media_real_get_skip_count (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 258 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 259 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "skipcount", &self->_skip_count);
#line 260 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_skip_count;
#line 260 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 260 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2235 "LocalMedia.c"
}

static void
noise_local_media_real_set_skip_count (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
#line 262 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 263 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "skipcount", value, &self->_skip_count);
#line 262 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY]);
#line 2249 "LocalMedia.c"
}

static guint
noise_local_media_real_get_date_added (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 269 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 270 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "dateadded", &self->_date_added);
#line 271 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_date_added;
#line 271 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 271 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2268 "LocalMedia.c"
}

static void
noise_local_media_real_set_date_added (NoiseMedia* base,
                                       guint value)
{
	NoiseLocalMedia* self;
#line 273 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 274 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "dateadded", value, &self->_date_added);
#line 273 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY]);
#line 2282 "LocalMedia.c"
}

static guint
noise_local_media_real_get_last_played (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 280 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 281 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "lastplayed", &self->_last_played);
#line 282 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_last_played;
#line 282 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 282 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2301 "LocalMedia.c"
}

static void
noise_local_media_real_set_last_played (NoiseMedia* base,
                                        guint value)
{
	NoiseLocalMedia* self;
#line 284 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 285 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "lastplayed", value, &self->_last_played);
#line 284 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY]);
#line 2315 "LocalMedia.c"
}

static guint
noise_local_media_real_get_last_modified (NoiseMedia* base)
{
	guint result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
#line 291 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 292 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "lastmodified", &self->_last_modified);
#line 293 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->_last_modified;
#line 293 "../src/LocalBackend/LocalMedia.vala"
	result = *_tmp0_;
#line 293 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2334 "LocalMedia.c"
}

static void
noise_local_media_real_set_last_modified (NoiseMedia* base,
                                          guint value)
{
	NoiseLocalMedia* self;
#line 295 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 296 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "lastmodified", value, &self->_last_modified);
#line 295 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY]);
#line 2348 "LocalMedia.c"
}

static gboolean
_uint_equal (const guint * s1,
             const guint * s2)
{
#line 304 "../src/LocalBackend/LocalMedia.vala"
	if (s1 == s2) {
#line 304 "../src/LocalBackend/LocalMedia.vala"
		return TRUE;
#line 2359 "LocalMedia.c"
	}
#line 304 "../src/LocalBackend/LocalMedia.vala"
	if (s1 == NULL) {
#line 304 "../src/LocalBackend/LocalMedia.vala"
		return FALSE;
#line 2365 "LocalMedia.c"
	}
#line 304 "../src/LocalBackend/LocalMedia.vala"
	if (s2 == NULL) {
#line 304 "../src/LocalBackend/LocalMedia.vala"
		return FALSE;
#line 2371 "LocalMedia.c"
	}
#line 304 "../src/LocalBackend/LocalMedia.vala"
	return (*s1) == (*s2);
#line 2375 "LocalMedia.c"
}

static gboolean
noise_local_media_real_get_show (NoiseMedia* base)
{
	gboolean result;
	NoiseLocalMedia* self;
	guint* _tmp0_;
	guint _tmp1_;
#line 302 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 303 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_getter (self, "show", &self->priv->_show);
#line 304 "../src/LocalBackend/LocalMedia.vala"
	_tmp0_ = self->priv->_show;
#line 304 "../src/LocalBackend/LocalMedia.vala"
	_tmp1_ = (guint) 1;
#line 304 "../src/LocalBackend/LocalMedia.vala"
	result = _uint_equal (_tmp0_, &_tmp1_) == TRUE;
#line 304 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2397 "LocalMedia.c"
}

static void
noise_local_media_real_set_show (NoiseMedia* base,
                                 gboolean value)
{
	NoiseLocalMedia* self;
	gint _tmp0_ = 0;
#line 306 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 307 "../src/LocalBackend/LocalMedia.vala"
	if (value) {
#line 307 "../src/LocalBackend/LocalMedia.vala"
		_tmp0_ = 1;
#line 2412 "LocalMedia.c"
	} else {
#line 307 "../src/LocalBackend/LocalMedia.vala"
		_tmp0_ = 0;
#line 2416 "LocalMedia.c"
	}
#line 307 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_common_uint_setter (self, "show", (guint) _tmp0_, &self->priv->_show);
#line 306 "../src/LocalBackend/LocalMedia.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_SHOW_PROPERTY]);
#line 2422 "LocalMedia.c"
}

static gint
noise_local_media_real_get_resume_pos (NoiseMedia* base)
{
	gint result;
	NoiseLocalMedia* self;
#line 311 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 311 "../src/LocalBackend/LocalMedia.vala"
	result = self->priv->_resume_pos;
#line 311 "../src/LocalBackend/LocalMedia.vala"
	return result;
#line 2436 "LocalMedia.c"
}

static void
noise_local_media_real_set_resume_pos (NoiseMedia* base,
                                       gint value)
{
	NoiseLocalMedia* self;
#line 311 "../src/LocalBackend/LocalMedia.vala"
	self = (NoiseLocalMedia*) base;
#line 311 "../src/LocalBackend/LocalMedia.vala"
	if (noise_local_media_real_get_resume_pos (base) != value) {
#line 311 "../src/LocalBackend/LocalMedia.vala"
		self->priv->_resume_pos = value;
#line 311 "../src/LocalBackend/LocalMedia.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_local_media_properties[NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY]);
#line 2452 "LocalMedia.c"
	}
}

static void
noise_local_media_class_init (NoiseLocalMediaClass * klass,
                              gpointer klass_data)
{
#line 29 "../src/LocalBackend/LocalMedia.vala"
	noise_local_media_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_type_class_adjust_private_offset (klass, &NoiseLocalMedia_private_offset);
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_file_size = noise_local_media_real_get_file_size;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_file_size = noise_local_media_real_set_file_size;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_title = noise_local_media_real_get_title;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_title = noise_local_media_real_set_title;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_track = noise_local_media_real_get_track;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_track = noise_local_media_real_set_track;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_track_count = noise_local_media_real_get_track_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_track_count = noise_local_media_real_set_track_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_composer = noise_local_media_real_get_composer;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_composer = noise_local_media_real_set_composer;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_artist = noise_local_media_real_get_artist;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_artist = noise_local_media_real_set_artist;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_artist = noise_local_media_real_get_album_artist;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_artist = noise_local_media_real_set_album_artist;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album = noise_local_media_real_get_album;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album = noise_local_media_real_set_album;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_number = noise_local_media_real_get_album_number;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_number = noise_local_media_real_set_album_number;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_count = noise_local_media_real_get_album_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_count = noise_local_media_real_set_album_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_info = noise_local_media_real_get_album_info;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_info = noise_local_media_real_set_album_info;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_grouping = noise_local_media_real_get_grouping;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_grouping = noise_local_media_real_set_grouping;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_genre = noise_local_media_real_get_genre;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_genre = noise_local_media_real_set_genre;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_comment = noise_local_media_real_get_comment;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_comment = noise_local_media_real_set_comment;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_lyrics = noise_local_media_real_get_lyrics;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_lyrics = noise_local_media_real_set_lyrics;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_year = noise_local_media_real_get_year;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_year = noise_local_media_real_set_year;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_bitrate = noise_local_media_real_get_bitrate;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_bitrate = noise_local_media_real_set_bitrate;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_samplerate = noise_local_media_real_get_samplerate;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_samplerate = noise_local_media_real_set_samplerate;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_length = noise_local_media_real_get_length;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_length = noise_local_media_real_set_length;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_rating = noise_local_media_real_get_rating;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_rating = noise_local_media_real_set_rating;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_play_count = noise_local_media_real_get_play_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_play_count = noise_local_media_real_set_play_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_skip_count = noise_local_media_real_get_skip_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_skip_count = noise_local_media_real_set_skip_count;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_date_added = noise_local_media_real_get_date_added;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_date_added = noise_local_media_real_set_date_added;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_played = noise_local_media_real_get_last_played;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_played = noise_local_media_real_set_last_played;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_modified = noise_local_media_real_get_last_modified;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_modified = noise_local_media_real_set_last_modified;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_show = noise_local_media_real_get_show;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_show = noise_local_media_real_set_show;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->get_resume_pos = noise_local_media_real_get_resume_pos;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	NOISE_MEDIA_CLASS (klass)->set_resume_pos = noise_local_media_real_set_resume_pos;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_local_media_get_property;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_local_media_set_property;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_local_media_finalize;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TITLE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TRACK_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ARTIST_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", NOISE_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_GROUPING_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_GENRE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_COMMENT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LYRICS_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_YEAR_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_BITRATE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LENGTH_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_RATING_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_SHOW_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/LocalBackend/LocalMedia.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY, noise_local_media_properties[NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2632 "LocalMedia.c"
}

static void
noise_local_media_instance_init (NoiseLocalMedia * self,
                                 gpointer klass)
{
#line 29 "../src/LocalBackend/LocalMedia.vala"
	self->priv = noise_local_media_get_instance_private (self);
#line 30 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_file_size = NULL;
#line 44 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_title = NULL;
#line 55 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_track = NULL;
#line 66 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_track_count = NULL;
#line 77 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_composer = NULL;
#line 88 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_artist = NULL;
#line 99 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_album_artist = NULL;
#line 110 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_album = NULL;
#line 121 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_album_number = NULL;
#line 132 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_album_count = NULL;
#line 143 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_album_info = NULL;
#line 144 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_grouping = NULL;
#line 155 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_genre = NULL;
#line 166 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_comment = NULL;
#line 177 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_lyrics = NULL;
#line 188 "../src/LocalBackend/LocalMedia.vala"
	self->_year = NULL;
#line 199 "../src/LocalBackend/LocalMedia.vala"
	self->_bitrate = NULL;
#line 210 "../src/LocalBackend/LocalMedia.vala"
	self->_samplerate = NULL;
#line 221 "../src/LocalBackend/LocalMedia.vala"
	self->_length = NULL;
#line 245 "../src/LocalBackend/LocalMedia.vala"
	self->_play_count = NULL;
#line 256 "../src/LocalBackend/LocalMedia.vala"
	self->_skip_count = NULL;
#line 267 "../src/LocalBackend/LocalMedia.vala"
	self->_date_added = NULL;
#line 278 "../src/LocalBackend/LocalMedia.vala"
	self->_last_played = NULL;
#line 289 "../src/LocalBackend/LocalMedia.vala"
	self->_last_modified = NULL;
#line 300 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_show = NULL;
#line 311 "../src/LocalBackend/LocalMedia.vala"
	self->priv->_resume_pos = 0;
#line 2693 "LocalMedia.c"
}

static void
noise_local_media_finalize (GObject * obj)
{
	NoiseLocalMedia * self;
#line 29 "../src/LocalBackend/LocalMedia.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
#line 30 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_file_size);
#line 44 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_title);
#line 55 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_track);
#line 66 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_track_count);
#line 77 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_composer);
#line 88 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_artist);
#line 99 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album_artist);
#line 110 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album);
#line 121 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album_number);
#line 132 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_album_count);
#line 144 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_grouping);
#line 155 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_genre);
#line 166 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_comment);
#line 177 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_lyrics);
#line 188 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_year);
#line 199 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_bitrate);
#line 210 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_samplerate);
#line 221 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_length);
#line 245 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_play_count);
#line 256 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_skip_count);
#line 267 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_date_added);
#line 278 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_last_played);
#line 289 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->_last_modified);
#line 300 "../src/LocalBackend/LocalMedia.vala"
	_g_free0 (self->priv->_show);
#line 313 "../src/LocalBackend/LocalMedia.vala"
	_g_object_unref0 (self->priv->connection);
#line 29 "../src/LocalBackend/LocalMedia.vala"
	G_OBJECT_CLASS (noise_local_media_parent_class)->finalize (obj);
#line 2754 "LocalMedia.c"
}

GType
noise_local_media_get_type (void)
{
	static volatile gsize noise_local_media_type_id__volatile = 0;
	if (g_once_init_enter (&noise_local_media_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseLocalMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_local_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseLocalMedia), 0, (GInstanceInitFunc) noise_local_media_instance_init, NULL };
		GType noise_local_media_type_id;
		noise_local_media_type_id = g_type_register_static (NOISE_TYPE_MEDIA, "NoiseLocalMedia", &g_define_type_info, 0);
		NoiseLocalMedia_private_offset = g_type_add_instance_private (noise_local_media_type_id, sizeof (NoiseLocalMediaPrivate));
		g_once_init_leave (&noise_local_media_type_id__volatile, noise_local_media_type_id);
	}
	return noise_local_media_type_id__volatile;
}

static void
_vala_noise_local_media_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	NoiseLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
#line 29 "../src/LocalBackend/LocalMedia.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint64 (value, noise_media_get_file_size ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TITLE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_title ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_track ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_track_count ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_composer ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ARTIST_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_artist ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_album_artist ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_album ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_album_number ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_album_count ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_object (value, noise_media_get_album_info ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GROUPING_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_grouping ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GENRE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_genre ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMMENT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_comment ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LYRICS_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_string (value, noise_media_get_lyrics ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_YEAR_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_year ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_BITRATE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_bitrate ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_samplerate ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LENGTH_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_length ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RATING_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_rating ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_play_count ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_skip_count ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_date_added ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_last_played ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_uint (value, noise_media_get_last_modified ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SHOW_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_boolean (value, noise_media_get_show ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		g_value_set_int (value, noise_media_get_resume_pos ((NoiseMedia*) self));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 2943 "LocalMedia.c"
		default:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 2949 "LocalMedia.c"
	}
}

static void
_vala_noise_local_media_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	NoiseLocalMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_LOCAL_MEDIA, NoiseLocalMedia);
#line 29 "../src/LocalBackend/LocalMedia.vala"
	switch (property_id) {
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_FILE_SIZE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_file_size ((NoiseMedia*) self, g_value_get_uint64 (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TITLE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_title ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_track ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_TRACK_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_track_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMPOSER_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_composer ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ARTIST_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_artist ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_artist ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_album ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_number ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_ALBUM_INFO_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_album_info ((NoiseMedia*) self, g_value_get_object (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GROUPING_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_grouping ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_GENRE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_genre ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_COMMENT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_comment ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LYRICS_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_lyrics ((NoiseMedia*) self, g_value_get_string (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_YEAR_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_year ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_BITRATE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_bitrate ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SAMPLERATE_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_samplerate ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LENGTH_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_length ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RATING_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_rating ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_PLAY_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_play_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SKIP_COUNT_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_skip_count ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_DATE_ADDED_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_date_added ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_PLAYED_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_last_played ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_LAST_MODIFIED_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_last_modified ((NoiseMedia*) self, g_value_get_uint (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_SHOW_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_show ((NoiseMedia*) self, g_value_get_boolean (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 29 "../src/LocalBackend/LocalMedia.vala"
		case NOISE_LOCAL_MEDIA_RESUME_POS_PROPERTY:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		noise_media_set_resume_pos ((NoiseMedia*) self, g_value_get_int (value));
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 3125 "LocalMedia.c"
		default:
#line 29 "../src/LocalBackend/LocalMedia.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/LocalBackend/LocalMedia.vala"
		break;
#line 3131 "LocalMedia.c"
	}
}

