/* FastGrid.c generated by valac 0.44.3, the Vala compiler
 * generated from FastGrid.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <cairo.h>
#include <float.h>
#include <math.h>

#define NOISE_TYPE_FAST_GRID (noise_fast_grid_get_type ())
#define NOISE_FAST_GRID(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_GRID, NoiseFastGrid))
#define NOISE_FAST_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_GRID, NoiseFastGridClass))
#define NOISE_IS_FAST_GRID(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_GRID))
#define NOISE_IS_FAST_GRID_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_GRID))
#define NOISE_FAST_GRID_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_GRID, NoiseFastGridClass))

typedef struct _NoiseFastGrid NoiseFastGrid;
typedef struct _NoiseFastGridClass NoiseFastGridClass;
typedef struct _NoiseFastGridPrivate NoiseFastGridPrivate;
typedef void (*NoiseFastGridViewSearchFunc) (GeeHashMap* showing, gpointer user_data);
typedef gint (*NoiseFastGridSortCompareFunc) (GObject* a, GObject* b, gpointer user_data);

#define NOISE_TYPE_FAST_GRID_MODEL (noise_fast_grid_model_get_type ())
#define NOISE_FAST_GRID_MODEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_FAST_GRID_MODEL, NoiseFastGridModel))
#define NOISE_FAST_GRID_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_FAST_GRID_MODEL, NoiseFastGridModelClass))
#define NOISE_IS_FAST_GRID_MODEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_FAST_GRID_MODEL))
#define NOISE_IS_FAST_GRID_MODEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_FAST_GRID_MODEL))
#define NOISE_FAST_GRID_MODEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_FAST_GRID_MODEL, NoiseFastGridModelClass))

typedef struct _NoiseFastGridModel NoiseFastGridModel;
typedef struct _NoiseFastGridModelClass NoiseFastGridModelClass;
enum  {
	NOISE_FAST_GRID_0_PROPERTY,
	NOISE_FAST_GRID_NUM_PROPERTIES
};
static GParamSpec* noise_fast_grid_properties[NOISE_FAST_GRID_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define NOISE_WIDGETS_TYPE_TILE_RENDERER (noise_widgets_tile_renderer_get_type ())
#define NOISE_WIDGETS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRenderer))
#define NOISE_WIDGETS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))
#define NOISE_WIDGETS_IS_TILE_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_IS_TILE_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_WIDGETS_TYPE_TILE_RENDERER))
#define NOISE_WIDGETS_TILE_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_WIDGETS_TYPE_TILE_RENDERER, NoiseWidgetsTileRendererClass))

typedef struct _NoiseWidgetsTileRenderer NoiseWidgetsTileRenderer;
typedef struct _NoiseWidgetsTileRendererClass NoiseWidgetsTileRendererClass;

struct _NoiseFastGrid {
	GtkIconView parent_instance;
	NoiseFastGridPrivate * priv;
	gboolean research_needed;
};

struct _NoiseFastGridClass {
	GtkIconViewClass parent_class;
};

struct _NoiseFastGridPrivate {
	NoiseFastGridViewSearchFunc _search_func;
	gpointer _search_func_target;
	NoiseFastGridSortCompareFunc _compare_func;
	gpointer _compare_func_target;
	GtkCellRenderer* cell_renderer;
	NoiseFastGridModel* fm;
	GeeHashMap* table;
	GeeHashMap* showing;
};

static gint NoiseFastGrid_private_offset;
static gpointer noise_fast_grid_parent_class = NULL;

GType noise_fast_grid_get_type (void) G_GNUC_CONST;
GType noise_fast_grid_model_get_type (void) G_GNUC_CONST;
GeeMap* noise_fast_grid_get_table (NoiseFastGrid* self);
GeeMap* noise_fast_grid_get_visible_table (NoiseFastGrid* self);
GObject* noise_fast_grid_get_object_from_index (NoiseFastGrid* self,
                                                gint index);
void noise_fast_grid_set_table (NoiseFastGrid* self,
                                GeeHashMap* new_table,
                                gboolean do_resort);
static void noise_fast_grid_resort (NoiseFastGrid* self);
void noise_fast_grid_do_search (NoiseFastGrid* self);
void noise_fast_grid_remove_objects (NoiseFastGrid* self,
                                     GeeCollection* objects);
void noise_fast_grid_add_objects (NoiseFastGrid* self,
                                  GeeCollection* objects);
NoiseFastGridViewSearchFunc noise_fast_grid_get_search_func (NoiseFastGrid* self,
                                                             gpointer* result_target);
void noise_fast_grid_model_set_table (NoiseFastGridModel* self,
                                      GeeHashMap* table);
void noise_fast_grid_model_remove (NoiseFastGridModel* self,
                                   GtkTreeIter* iter);
void noise_fast_grid_model_append (NoiseFastGridModel* self,
                                   GtkTreeIter* iter);
static void noise_fast_grid_quicksort (NoiseFastGrid* self,
                                gint start,
                                gint end);
static void noise_fast_grid_swap (NoiseFastGrid* self,
                           gint a,
                           gint b);
NoiseFastGridSortCompareFunc noise_fast_grid_get_compare_func (NoiseFastGrid* self,
                                                               gpointer* result_target);
static void noise_fast_grid_real_size_allocate (GtkWidget* base,
                                         GtkAllocation* alloc);
NoiseFastGrid* noise_fast_grid_new (void);
NoiseFastGrid* noise_fast_grid_construct (GType object_type);
void noise_fast_grid_set_search_func (NoiseFastGrid* self,
                                      NoiseFastGridViewSearchFunc value,
                                      gpointer value_target);
void noise_fast_grid_set_compare_func (NoiseFastGrid* self,
                                       NoiseFastGridSortCompareFunc value,
                                       gpointer value_target);
static GObject * noise_fast_grid_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
NoiseFastGridModel* noise_fast_grid_model_new (void);
NoiseFastGridModel* noise_fast_grid_model_construct (GType object_type);
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_new (void);
NoiseWidgetsTileRenderer* noise_widgets_tile_renderer_construct (GType object_type);
GType noise_widgets_tile_renderer_get_type (void) G_GNUC_CONST;
static void noise_fast_grid_finalize (GObject * obj);
static void _vala_noise_fast_grid_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec);
static void _vala_noise_fast_grid_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec);

static inline gpointer
noise_fast_grid_get_instance_private (NoiseFastGrid* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseFastGrid_private_offset);
}

/** Should not be manipulated by client */
GeeMap*
noise_fast_grid_get_table (NoiseFastGrid* self)
{
	GeeMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
#line 65 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = _tmp1_;
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	result = _tmp2_;
#line 66 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 189 "FastGrid.c"
}

/** Should not be manipulated by client */
GeeMap*
noise_fast_grid_get_visible_table (NoiseFastGrid* self)
{
	GeeMap* result = NULL;
	GeeHashMap* _tmp0_;
	GeeMap* _tmp1_;
	GeeMap* _tmp2_;
#line 70 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->showing;
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp0_);
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = _tmp1_;
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	result = _tmp2_;
#line 71 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 212 "FastGrid.c"
}

GObject*
noise_fast_grid_get_object_from_index (NoiseFastGrid* self,
                                       gint index)
{
	GObject* result = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
#line 74 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->showing;
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) index));
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	result = (GObject*) _tmp1_;
#line 75 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 232 "FastGrid.c"
}

void
noise_fast_grid_set_table (NoiseFastGrid* self,
                           GeeHashMap* new_table,
                           gboolean do_resort)
{
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
#line 78 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (new_table != NULL);
#line 79 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 79 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 80 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = self->priv->table;
#line 80 "../src/Widgets/FastView/FastGrid.vala"
	gee_map_set_all ((GeeMap*) _tmp1_, (GeeMap*) new_table);
#line 82 "../src/Widgets/FastView/FastGrid.vala"
	if (do_resort) {
#line 83 "../src/Widgets/FastView/FastGrid.vala"
		noise_fast_grid_resort (self);
#line 258 "FastGrid.c"
	} else {
#line 85 "../src/Widgets/FastView/FastGrid.vala"
		noise_fast_grid_do_search (self);
#line 262 "FastGrid.c"
	}
}

void
noise_fast_grid_remove_objects (NoiseFastGrid* self,
                                GeeCollection* objects)
{
	GeeHashMap* to_remove = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp20_;
	GeeHashMap* _tmp21_;
#line 90 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 90 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (objects != NULL);
#line 91 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 91 "../src/Widgets/FastView/FastGrid.vala"
	to_remove = _tmp0_;
#line 282 "FastGrid.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp1_;
		GeeSet* _tmp2_;
		GeeSet* _tmp3_;
		GeeSet* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp1_ = self->priv->table;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp2_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp1_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp3_ = _tmp2_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp4_ = _tmp3_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_tmp6_ = _tmp5_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_g_object_unref0 (_tmp4_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_entry_it = _tmp6_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 309 "FastGrid.c"
			GeeIterator* _tmp7_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeMapEntry* _tmp10_;
			gconstpointer _tmp11_;
			GObject* _tmp12_;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_tmp7_ = _entry_it;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 92 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 323 "FastGrid.c"
			}
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_tmp8_ = _entry_it;
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			entry = (GeeMapEntry*) _tmp9_;
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			_tmp10_ = entry;
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			_tmp11_ = gee_map_entry_get_value (_tmp10_);
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			_tmp12_ = _tmp11_;
#line 93 "../src/Widgets/FastView/FastGrid.vala"
			if (gee_collection_contains (objects, (GObject*) _tmp12_)) {
#line 339 "FastGrid.c"
				GeeHashMap* _tmp13_;
				GeeMapEntry* _tmp14_;
				gconstpointer _tmp15_;
				gint _tmp16_;
				GeeMapEntry* _tmp17_;
				gconstpointer _tmp18_;
				GObject* _tmp19_;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp13_ = to_remove;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp14_ = entry;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp15_ = gee_map_entry_get_key (_tmp14_);
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp16_ = _tmp15_;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp17_ = entry;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp18_ = gee_map_entry_get_value (_tmp17_);
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				_tmp19_ = _tmp18_;
#line 94 "../src/Widgets/FastView/FastGrid.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, (gpointer) ((gintptr) ((gint) ((gintptr) _tmp16_))), (GObject*) _tmp19_);
#line 363 "FastGrid.c"
			}
#line 92 "../src/Widgets/FastView/FastGrid.vala"
			_g_object_unref0 (entry);
#line 367 "FastGrid.c"
		}
#line 92 "../src/Widgets/FastView/FastGrid.vala"
		_g_object_unref0 (_entry_it);
#line 371 "FastGrid.c"
	}
#line 98 "../src/Widgets/FastView/FastGrid.vala"
	_tmp20_ = self->priv->table;
#line 98 "../src/Widgets/FastView/FastGrid.vala"
	_tmp21_ = to_remove;
#line 98 "../src/Widgets/FastView/FastGrid.vala"
	gee_map_unset_all ((GeeMap*) _tmp20_, (GeeMap*) _tmp21_);
#line 100 "../src/Widgets/FastView/FastGrid.vala"
	noise_fast_grid_do_search (self);
#line 90 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (to_remove);
#line 383 "FastGrid.c"
}

void
noise_fast_grid_add_objects (NoiseFastGrid* self,
                             GeeCollection* objects)
{
#line 104 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (objects != NULL);
#line 394 "FastGrid.c"
	{
		GeeIterator* _o_it = NULL;
		GeeIterator* _tmp0_;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) objects);
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		_o_it = _tmp0_;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 404 "FastGrid.c"
			GeeIterator* _tmp1_;
			GObject* o = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			GeeHashMap* _tmp4_;
			GeeHashMap* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GObject* _tmp8_;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_tmp1_ = _o_it;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 106 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 420 "FastGrid.c"
			}
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_tmp2_ = _o_it;
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			o = (GObject*) _tmp3_;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp4_ = self->priv->table;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp5_ = self->priv->table;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp6_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp5_);
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp7_ = _tmp6_;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			_tmp8_ = o;
#line 107 "../src/Widgets/FastView/FastGrid.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, (gpointer) ((gintptr) _tmp7_), _tmp8_);
#line 106 "../src/Widgets/FastView/FastGrid.vala"
			_g_object_unref0 (o);
#line 442 "FastGrid.c"
		}
#line 106 "../src/Widgets/FastView/FastGrid.vala"
		_g_object_unref0 (_o_it);
#line 446 "FastGrid.c"
	}
#line 111 "../src/Widgets/FastView/FastGrid.vala"
	noise_fast_grid_resort (self);
#line 450 "FastGrid.c"
}

void
noise_fast_grid_do_search (NoiseFastGrid* self)
{
	gboolean _tmp0_ = FALSE;
	NoiseFastGridViewSearchFunc _tmp1_;
	gpointer _tmp1__target;
	NoiseFastGridViewSearchFunc _tmp2_;
	gpointer _tmp2__target;
	gint old_size = 0;
	GeeHashMap* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GeeHashMap* _tmp6_;
	NoiseFastGridViewSearchFunc _tmp7_;
	gpointer _tmp7__target;
	NoiseFastGridViewSearchFunc _tmp8_;
	gpointer _tmp8__target;
	GeeHashMap* _tmp9_;
	GeeHashMap* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
#line 114 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = noise_fast_grid_get_search_func (self, &_tmp1__target);
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = _tmp1_;
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2__target = _tmp1__target;
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	if (_tmp2_ == NULL) {
#line 115 "../src/Widgets/FastView/FastGrid.vala"
		_tmp0_ = TRUE;
#line 486 "FastGrid.c"
	} else {
#line 115 "../src/Widgets/FastView/FastGrid.vala"
		_tmp0_ = self->research_needed == FALSE;
#line 490 "FastGrid.c"
	}
#line 115 "../src/Widgets/FastView/FastGrid.vala"
	if (_tmp0_) {
#line 116 "../src/Widgets/FastView/FastGrid.vala"
		return;
#line 496 "FastGrid.c"
	}
#line 119 "../src/Widgets/FastView/FastGrid.vala"
	self->research_needed = FALSE;
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = self->priv->showing;
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	_tmp4_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp3_);
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = _tmp4_;
#line 120 "../src/Widgets/FastView/FastGrid.vala"
	old_size = _tmp5_;
#line 122 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = self->priv->showing;
#line 122 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp6_);
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp7_ = noise_fast_grid_get_search_func (self, &_tmp7__target);
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp8_ = _tmp7_;
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp8__target = _tmp7__target;
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp9_ = self->priv->showing;
#line 123 "../src/Widgets/FastView/FastGrid.vala"
	_tmp8_ (_tmp9_, _tmp8__target);
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	_tmp10_ = self->priv->showing;
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	_tmp11_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp10_);
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	_tmp12_ = _tmp11_;
#line 125 "../src/Widgets/FastView/FastGrid.vala"
	if (_tmp12_ == old_size) {
#line 530 "FastGrid.c"
		NoiseFastGridModel* _tmp13_;
		GeeHashMap* _tmp14_;
#line 126 "../src/Widgets/FastView/FastGrid.vala"
		_tmp13_ = self->priv->fm;
#line 126 "../src/Widgets/FastView/FastGrid.vala"
		_tmp14_ = self->priv->showing;
#line 126 "../src/Widgets/FastView/FastGrid.vala"
		noise_fast_grid_model_set_table (_tmp13_, _tmp14_);
#line 127 "../src/Widgets/FastView/FastGrid.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 541 "FastGrid.c"
	} else {
#line 128 "../src/Widgets/FastView/FastGrid.vala"
		if (old_size == 0) {
#line 545 "FastGrid.c"
			NoiseFastGridModel* _tmp15_;
			GeeHashMap* _tmp16_;
			NoiseFastGridModel* _tmp17_;
#line 129 "../src/Widgets/FastView/FastGrid.vala"
			gtk_icon_view_set_model ((GtkIconView*) self, NULL);
#line 130 "../src/Widgets/FastView/FastGrid.vala"
			_tmp15_ = self->priv->fm;
#line 130 "../src/Widgets/FastView/FastGrid.vala"
			_tmp16_ = self->priv->showing;
#line 130 "../src/Widgets/FastView/FastGrid.vala"
			noise_fast_grid_model_set_table (_tmp15_, _tmp16_);
#line 131 "../src/Widgets/FastView/FastGrid.vala"
			_tmp17_ = self->priv->fm;
#line 131 "../src/Widgets/FastView/FastGrid.vala"
			gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp17_);
#line 561 "FastGrid.c"
		} else {
			GeeHashMap* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			_tmp18_ = self->priv->showing;
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			_tmp19_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp18_);
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			_tmp20_ = _tmp19_;
#line 132 "../src/Widgets/FastView/FastGrid.vala"
			if (old_size > _tmp20_) {
#line 574 "FastGrid.c"
				NoiseFastGridModel* _tmp30_;
				GeeHashMap* _tmp31_;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
				while (TRUE) {
#line 579 "FastGrid.c"
					NoiseFastGridModel* _tmp21_;
					GeeHashMap* _tmp22_;
					gint _tmp23_;
					gint _tmp24_;
					GtkTreeIter iter = {0};
					NoiseFastGridModel* _tmp25_;
					NoiseFastGridModel* _tmp26_;
					GtkTreeIter _tmp27_ = {0};
					NoiseFastGridModel* _tmp28_;
					GtkTreeIter _tmp29_;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp21_ = self->priv->fm;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp22_ = self->priv->showing;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp23_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp22_);
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					_tmp24_ = _tmp23_;
#line 133 "../src/Widgets/FastView/FastGrid.vala"
					if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp21_, NULL) > _tmp24_)) {
#line 133 "../src/Widgets/FastView/FastGrid.vala"
						break;
#line 602 "FastGrid.c"
					}
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					_tmp25_ = self->priv->fm;
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					_tmp26_ = self->priv->fm;
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					gtk_tree_model_iter_nth_child ((GtkTreeModel*) _tmp25_, &_tmp27_, NULL, gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp26_, NULL) - 1);
#line 135 "../src/Widgets/FastView/FastGrid.vala"
					iter = _tmp27_;
#line 136 "../src/Widgets/FastView/FastGrid.vala"
					_tmp28_ = self->priv->fm;
#line 136 "../src/Widgets/FastView/FastGrid.vala"
					_tmp29_ = iter;
#line 136 "../src/Widgets/FastView/FastGrid.vala"
					noise_fast_grid_model_remove (_tmp28_, &_tmp29_);
#line 618 "FastGrid.c"
				}
#line 139 "../src/Widgets/FastView/FastGrid.vala"
				_tmp30_ = self->priv->fm;
#line 139 "../src/Widgets/FastView/FastGrid.vala"
				_tmp31_ = self->priv->showing;
#line 139 "../src/Widgets/FastView/FastGrid.vala"
				noise_fast_grid_model_set_table (_tmp30_, _tmp31_);
#line 140 "../src/Widgets/FastView/FastGrid.vala"
				gtk_widget_queue_draw ((GtkWidget*) self);
#line 628 "FastGrid.c"
			} else {
				GeeHashMap* _tmp32_;
				gint _tmp33_;
				gint _tmp34_;
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				_tmp32_ = self->priv->showing;
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				_tmp33_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp32_);
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				_tmp34_ = _tmp33_;
#line 141 "../src/Widgets/FastView/FastGrid.vala"
				if (_tmp34_ > old_size) {
#line 641 "FastGrid.c"
					GtkTreeIter iter = {0};
					NoiseFastGridModel* _tmp41_;
					GeeHashMap* _tmp42_;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
					while (TRUE) {
#line 647 "FastGrid.c"
						NoiseFastGridModel* _tmp35_;
						GeeHashMap* _tmp36_;
						gint _tmp37_;
						gint _tmp38_;
						NoiseFastGridModel* _tmp39_;
						GtkTreeIter _tmp40_ = {0};
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp35_ = self->priv->fm;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp36_ = self->priv->showing;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp37_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp36_);
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						_tmp38_ = _tmp37_;
#line 144 "../src/Widgets/FastView/FastGrid.vala"
						if (!(gtk_tree_model_iter_n_children ((GtkTreeModel*) _tmp35_, NULL) < _tmp38_)) {
#line 144 "../src/Widgets/FastView/FastGrid.vala"
							break;
#line 666 "FastGrid.c"
						}
#line 145 "../src/Widgets/FastView/FastGrid.vala"
						_tmp39_ = self->priv->fm;
#line 145 "../src/Widgets/FastView/FastGrid.vala"
						noise_fast_grid_model_append (_tmp39_, &_tmp40_);
#line 145 "../src/Widgets/FastView/FastGrid.vala"
						iter = _tmp40_;
#line 674 "FastGrid.c"
					}
#line 148 "../src/Widgets/FastView/FastGrid.vala"
					_tmp41_ = self->priv->fm;
#line 148 "../src/Widgets/FastView/FastGrid.vala"
					_tmp42_ = self->priv->showing;
#line 148 "../src/Widgets/FastView/FastGrid.vala"
					noise_fast_grid_model_set_table (_tmp41_, _tmp42_);
#line 149 "../src/Widgets/FastView/FastGrid.vala"
					gtk_widget_queue_draw ((GtkWidget*) self);
#line 684 "FastGrid.c"
				}
			}
		}
	}
}

static void
noise_fast_grid_resort (NoiseFastGrid* self)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 153 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/Widgets/FastView/FastGrid.vala"
	noise_fast_grid_quicksort (self, 0, _tmp2_ - 1);
#line 155 "../src/Widgets/FastView/FastGrid.vala"
	noise_fast_grid_do_search (self);
#line 709 "FastGrid.c"
}

static void
noise_fast_grid_swap (NoiseFastGrid* self,
                      gint a,
                      gint b)
{
	GObject* temp = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	gpointer _tmp4_;
	GObject* _tmp5_;
	GeeHashMap* _tmp6_;
#line 158 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 159 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 159 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) a));
#line 159 "../src/Widgets/FastView/FastGrid.vala"
	temp = (GObject*) _tmp1_;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = self->priv->table;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = self->priv->table;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp4_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp3_, (gpointer) ((gintptr) b));
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = (GObject*) _tmp4_;
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, (gpointer) ((gintptr) a), _tmp5_);
#line 160 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (_tmp5_);
#line 161 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = self->priv->table;
#line 161 "../src/Widgets/FastView/FastGrid.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, (gpointer) ((gintptr) b), temp);
#line 158 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (temp);
#line 751 "FastGrid.c"
}

static void
noise_fast_grid_quicksort (NoiseFastGrid* self,
                           gint start,
                           gint end)
{
	GObject* pivot = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	gint i = 0;
	gint j = 0;
#line 164 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 165 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->table;
#line 165 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((gintptr) ((start + end) / 2)));
#line 165 "../src/Widgets/FastView/FastGrid.vala"
	pivot = (GObject*) _tmp1_;
#line 166 "../src/Widgets/FastView/FastGrid.vala"
	i = start;
#line 167 "../src/Widgets/FastView/FastGrid.vala"
	j = end;
#line 169 "../src/Widgets/FastView/FastGrid.vala"
	while (TRUE) {
#line 169 "../src/Widgets/FastView/FastGrid.vala"
		if (!(i <= j)) {
#line 169 "../src/Widgets/FastView/FastGrid.vala"
			break;
#line 782 "FastGrid.c"
		}
#line 170 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 786 "FastGrid.c"
			gboolean _tmp2_ = FALSE;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
			if (i < end) {
#line 790 "FastGrid.c"
				NoiseFastGridSortCompareFunc _tmp3_;
				gpointer _tmp3__target;
				NoiseFastGridSortCompareFunc _tmp4_;
				gpointer _tmp4__target;
				GeeHashMap* _tmp5_;
				gpointer _tmp6_;
				GObject* _tmp7_;
				GObject* _tmp8_;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp3_ = noise_fast_grid_get_compare_func (self, &_tmp3__target);
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp4_ = _tmp3_;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp4__target = _tmp3__target;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp5_ = self->priv->table;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp5_, (gpointer) ((gintptr) i));
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp7_ = (GObject*) _tmp6_;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp8_ = pivot;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp2_ = _tmp4_ (_tmp7_, _tmp8_, _tmp4__target) < 0;
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_g_object_unref0 (_tmp7_);
#line 817 "FastGrid.c"
			} else {
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				_tmp2_ = FALSE;
#line 821 "FastGrid.c"
			}
#line 170 "../src/Widgets/FastView/FastGrid.vala"
			if (!_tmp2_) {
#line 170 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 827 "FastGrid.c"
			}
#line 170 "../src/Widgets/FastView/FastGrid.vala"
			i = i + 1;
#line 831 "FastGrid.c"
		}
#line 171 "../src/Widgets/FastView/FastGrid.vala"
		while (TRUE) {
#line 835 "FastGrid.c"
			gboolean _tmp9_ = FALSE;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
			if (j > start) {
#line 839 "FastGrid.c"
				NoiseFastGridSortCompareFunc _tmp10_;
				gpointer _tmp10__target;
				NoiseFastGridSortCompareFunc _tmp11_;
				gpointer _tmp11__target;
				GeeHashMap* _tmp12_;
				gpointer _tmp13_;
				GObject* _tmp14_;
				GObject* _tmp15_;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp10_ = noise_fast_grid_get_compare_func (self, &_tmp10__target);
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp11_ = _tmp10_;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp11__target = _tmp10__target;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp12_ = self->priv->table;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp13_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, (gpointer) ((gintptr) j));
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp14_ = (GObject*) _tmp13_;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp15_ = pivot;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp9_ = _tmp11_ (_tmp14_, _tmp15_, _tmp11__target) > 0;
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_g_object_unref0 (_tmp14_);
#line 866 "FastGrid.c"
			} else {
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				_tmp9_ = FALSE;
#line 870 "FastGrid.c"
			}
#line 171 "../src/Widgets/FastView/FastGrid.vala"
			if (!_tmp9_) {
#line 171 "../src/Widgets/FastView/FastGrid.vala"
				break;
#line 876 "FastGrid.c"
			}
#line 171 "../src/Widgets/FastView/FastGrid.vala"
			j = j - 1;
#line 880 "FastGrid.c"
		}
#line 173 "../src/Widgets/FastView/FastGrid.vala"
		if (i <= j) {
#line 174 "../src/Widgets/FastView/FastGrid.vala"
			noise_fast_grid_swap (self, i, j);
#line 175 "../src/Widgets/FastView/FastGrid.vala"
			i = i + 1;
#line 175 "../src/Widgets/FastView/FastGrid.vala"
			j = j - 1;
#line 890 "FastGrid.c"
		}
	}
#line 179 "../src/Widgets/FastView/FastGrid.vala"
	if (start < j) {
#line 180 "../src/Widgets/FastView/FastGrid.vala"
		noise_fast_grid_quicksort (self, start, j);
#line 897 "FastGrid.c"
	}
#line 182 "../src/Widgets/FastView/FastGrid.vala"
	if (i < end) {
#line 183 "../src/Widgets/FastView/FastGrid.vala"
		noise_fast_grid_quicksort (self, i, end);
#line 903 "FastGrid.c"
	}
#line 164 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (pivot);
#line 907 "FastGrid.c"
}

static void
noise_fast_grid_real_size_allocate (GtkWidget* base,
                                    GtkAllocation* alloc)
{
	NoiseFastGrid * self;
	GtkRequisition minimum_size = {0};
	GtkRequisition natural_size = {0};
	GtkCellRenderer* _tmp0_;
	GtkRequisition _tmp1_ = {0};
	GtkRequisition _tmp2_ = {0};
	gint item_width = 0;
	GtkRequisition _tmp3_;
	gint total_width = 0;
	GtkAllocation _tmp5_;
	gdouble num = 0.0;
	gint _tmp6_;
	gint _tmp7_;
	gdouble denom = 0.0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GtkAllocation _tmp14_;
#line 187 "../src/Widgets/FastView/FastGrid.vala"
	self = (NoiseFastGrid*) base;
#line 187 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (alloc != NULL);
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->cell_renderer;
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	gtk_cell_renderer_get_preferred_size (_tmp0_, (GtkWidget*) self, &_tmp1_, &_tmp2_);
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	minimum_size = _tmp1_;
#line 190 "../src/Widgets/FastView/FastGrid.vala"
	natural_size = _tmp2_;
#line 191 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = minimum_size;
#line 191 "../src/Widgets/FastView/FastGrid.vala"
	item_width = _tmp3_.width;
#line 193 "../src/Widgets/FastView/FastGrid.vala"
	if (item_width <= 0) {
#line 953 "FastGrid.c"
		GtkAllocation _tmp4_;
#line 194 "../src/Widgets/FastView/FastGrid.vala"
		_tmp4_ = *alloc;
#line 194 "../src/Widgets/FastView/FastGrid.vala"
		GTK_WIDGET_CLASS (noise_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp4_);
#line 959 "FastGrid.c"
	}
#line 197 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = *alloc;
#line 197 "../src/Widgets/FastView/FastGrid.vala"
	total_width = _tmp5_.width;
#line 200 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = gtk_icon_view_get_margin ((GtkIconView*) self);
#line 200 "../src/Widgets/FastView/FastGrid.vala"
	_tmp7_ = _tmp6_;
#line 200 "../src/Widgets/FastView/FastGrid.vala"
	num = (gdouble) (total_width - (2 * _tmp7_));
#line 201 "../src/Widgets/FastView/FastGrid.vala"
	denom = (gdouble) item_width;
#line 202 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_columns ((GtkIconView*) self, (gint) (num / denom));
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp8_ = gtk_icon_view_get_columns ((GtkIconView*) self);
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp9_ = _tmp8_;
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp10_ = gtk_icon_view_get_margin ((GtkIconView*) self);
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	_tmp11_ = _tmp10_;
#line 205 "../src/Widgets/FastView/FastGrid.vala"
	num = (gdouble) ((total_width - (_tmp9_ * item_width)) - (2 * _tmp11_));
#line 206 "../src/Widgets/FastView/FastGrid.vala"
	_tmp12_ = gtk_icon_view_get_columns ((GtkIconView*) self);
#line 206 "../src/Widgets/FastView/FastGrid.vala"
	_tmp13_ = _tmp12_;
#line 206 "../src/Widgets/FastView/FastGrid.vala"
	denom = (gdouble) (_tmp13_ - 1);
#line 207 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_column_spacing ((GtkIconView*) self, (gint) (num / denom));
#line 209 "../src/Widgets/FastView/FastGrid.vala"
	_tmp14_ = *alloc;
#line 209 "../src/Widgets/FastView/FastGrid.vala"
	GTK_WIDGET_CLASS (noise_fast_grid_parent_class)->size_allocate ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_icon_view_get_type (), GtkIconView), &_tmp14_);
#line 997 "FastGrid.c"
}

NoiseFastGrid*
noise_fast_grid_construct (GType object_type)
{
	NoiseFastGrid * self = NULL;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	self = (NoiseFastGrid*) g_object_new (object_type, NULL);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	return self;
#line 1008 "FastGrid.c"
}

NoiseFastGrid*
noise_fast_grid_new (void)
{
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	return noise_fast_grid_construct (NOISE_TYPE_FAST_GRID);
#line 1016 "FastGrid.c"
}

NoiseFastGridViewSearchFunc
noise_fast_grid_get_search_func (NoiseFastGrid* self,
                                 gpointer* result_target)
{
	NoiseFastGridViewSearchFunc result;
	NoiseFastGridViewSearchFunc _tmp0_;
	gpointer _tmp0__target;
	NoiseFastGridViewSearchFunc _tmp1_;
	gpointer _tmp1__target;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->_search_func;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0__target = self->priv->_search_func_target;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = _tmp0_;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1__target = _tmp0__target;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	*result_target = _tmp1__target;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	result = _tmp1_;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 1044 "FastGrid.c"
}

void
noise_fast_grid_set_search_func (NoiseFastGrid* self,
                                 NoiseFastGridViewSearchFunc value,
                                 gpointer value_target)
{
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->_search_func = value;
#line 31 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->_search_func_target = value_target;
#line 1058 "FastGrid.c"
}

NoiseFastGridSortCompareFunc
noise_fast_grid_get_compare_func (NoiseFastGrid* self,
                                  gpointer* result_target)
{
	NoiseFastGridSortCompareFunc result;
	NoiseFastGridSortCompareFunc _tmp0_;
	gpointer _tmp0__target;
	NoiseFastGridSortCompareFunc _tmp1_;
	gpointer _tmp1__target;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = self->priv->_compare_func;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0__target = self->priv->_compare_func_target;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = _tmp0_;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1__target = _tmp0__target;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	*result_target = _tmp1__target;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	result = _tmp1_;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	return result;
#line 1086 "FastGrid.c"
}

void
noise_fast_grid_set_compare_func (NoiseFastGrid* self,
                                  NoiseFastGridSortCompareFunc value,
                                  gpointer value_target)
{
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->_compare_func = value;
#line 34 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->_compare_func_target = value_target;
#line 1100 "FastGrid.c"
}

static GObject *
noise_fast_grid_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	NoiseFastGrid * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	NoiseFastGridModel* _tmp2_;
	GeeHashMap* _tmp3_;
	NoiseFastGridModel* _tmp4_;
	NoiseWidgetsTileRenderer* _tmp5_;
	GtkCellRenderer* _tmp6_;
	GtkCellRenderer* _tmp7_;
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	parent_class = G_OBJECT_CLASS (noise_fast_grid_parent_class);
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
#line 44 "../src/Widgets/FastView/FastGrid.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 44 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->table);
#line 44 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->table = _tmp0_;
#line 45 "../src/Widgets/FastView/FastGrid.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_INT, NULL, NULL, G_TYPE_OBJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 45 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->showing);
#line 45 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->showing = _tmp1_;
#line 46 "../src/Widgets/FastView/FastGrid.vala"
	_tmp2_ = noise_fast_grid_model_new ();
#line 46 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->fm);
#line 46 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->fm = _tmp2_;
#line 48 "../src/Widgets/FastView/FastGrid.vala"
	_tmp3_ = self->priv->table;
#line 48 "../src/Widgets/FastView/FastGrid.vala"
	noise_fast_grid_set_table (self, _tmp3_, TRUE);
#line 49 "../src/Widgets/FastView/FastGrid.vala"
	_tmp4_ = self->priv->fm;
#line 49 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_model ((GtkIconView*) self, (GtkTreeModel*) _tmp4_);
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	_tmp5_ = noise_widgets_tile_renderer_new ();
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	g_object_ref_sink (_tmp5_);
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->cell_renderer);
#line 51 "../src/Widgets/FastView/FastGrid.vala"
	self->priv->cell_renderer = (GtkCellRenderer*) _tmp5_;
#line 52 "../src/Widgets/FastView/FastGrid.vala"
	_tmp6_ = self->priv->cell_renderer;
#line 52 "../src/Widgets/FastView/FastGrid.vala"
	gtk_cell_layout_pack_start ((GtkCellLayout*) self, _tmp6_, FALSE);
#line 53 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_activate_on_single_click ((GtkIconView*) self, FALSE);
#line 54 "../src/Widgets/FastView/FastGrid.vala"
	_tmp7_ = self->priv->cell_renderer;
#line 54 "../src/Widgets/FastView/FastGrid.vala"
	gtk_cell_layout_add_attribute ((GtkCellLayout*) self, _tmp7_, "album", 0);
#line 55 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_tooltip_column ((GtkIconView*) self, 1);
#line 58 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_item_padding ((GtkIconView*) self, 0);
#line 61 "../src/Widgets/FastView/FastGrid.vala"
	gtk_icon_view_set_margin ((GtkIconView*) self, 24);
#line 43 "../src/Widgets/FastView/FastGrid.vala"
	return obj;
#line 1177 "FastGrid.c"
}

static void
noise_fast_grid_class_init (NoiseFastGridClass * klass,
                            gpointer klass_data)
{
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	noise_fast_grid_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	g_type_class_adjust_private_offset (klass, &NoiseFastGrid_private_offset);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, GtkAllocation*)) noise_fast_grid_real_size_allocate;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_fast_grid_get_property;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_fast_grid_set_property;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (klass)->constructor = noise_fast_grid_constructor;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_fast_grid_finalize;
#line 1198 "FastGrid.c"
}

static void
noise_fast_grid_instance_init (NoiseFastGrid * self,
                               gpointer klass)
{
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	self->priv = noise_fast_grid_get_instance_private (self);
#line 36 "../src/Widgets/FastView/FastGrid.vala"
	self->research_needed = FALSE;
#line 1209 "FastGrid.c"
}

static void
noise_fast_grid_finalize (GObject * obj)
{
	NoiseFastGrid * self;
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
#line 38 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->cell_renderer);
#line 39 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->fm);
#line 40 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->table);
#line 41 "../src/Widgets/FastView/FastGrid.vala"
	_g_object_unref0 (self->priv->showing);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	G_OBJECT_CLASS (noise_fast_grid_parent_class)->finalize (obj);
#line 1228 "FastGrid.c"
}

GType
noise_fast_grid_get_type (void)
{
	static volatile gsize noise_fast_grid_type_id__volatile = 0;
	if (g_once_init_enter (&noise_fast_grid_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseFastGridClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_fast_grid_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseFastGrid), 0, (GInstanceInitFunc) noise_fast_grid_instance_init, NULL };
		GType noise_fast_grid_type_id;
		noise_fast_grid_type_id = g_type_register_static (gtk_icon_view_get_type (), "NoiseFastGrid", &g_define_type_info, 0);
		NoiseFastGrid_private_offset = g_type_add_instance_private (noise_fast_grid_type_id, sizeof (NoiseFastGridPrivate));
		g_once_init_leave (&noise_fast_grid_type_id__volatile, noise_fast_grid_type_id);
	}
	return noise_fast_grid_type_id__volatile;
}

static void
_vala_noise_fast_grid_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec)
{
	NoiseFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	switch (property_id) {
#line 1255 "FastGrid.c"
		default:
#line 29 "../src/Widgets/FastView/FastGrid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
		break;
#line 1261 "FastGrid.c"
	}
}

static void
_vala_noise_fast_grid_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec)
{
	NoiseFastGrid * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_FAST_GRID, NoiseFastGrid);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
	switch (property_id) {
#line 1275 "FastGrid.c"
		default:
#line 29 "../src/Widgets/FastView/FastGrid.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/Widgets/FastView/FastGrid.vala"
		break;
#line 1281 "FastGrid.c"
	}
}

