/* AudioPlayerDevice.c generated by valac 0.44.3, the Vala compiler
 * generated from AudioPlayerDevice.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <glib-object.h>
#include "io.elementary.music-core.h"
#include <gio/gio.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "music-lib.h"
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>

#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE (noise_plugins_audio_player_device_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE))
#define NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDeviceClass))

typedef struct _NoisePluginsAudioPlayerDevice NoisePluginsAudioPlayerDevice;
typedef struct _NoisePluginsAudioPlayerDeviceClass NoisePluginsAudioPlayerDeviceClass;
typedef struct _NoisePluginsAudioPlayerDevicePrivate NoisePluginsAudioPlayerDevicePrivate;

#define NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY (noise_plugins_audio_player_library_get_type ())
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibrary))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_IS_AUDIO_PLAYER_LIBRARY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY))
#define NOISE_PLUGINS_AUDIO_PLAYER_LIBRARY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_PLUGINS_TYPE_AUDIO_PLAYER_LIBRARY, NoisePluginsAudioPlayerLibraryClass))

typedef struct _NoisePluginsAudioPlayerLibrary NoisePluginsAudioPlayerLibrary;
typedef struct _NoisePluginsAudioPlayerLibraryClass NoisePluginsAudioPlayerLibraryClass;
enum  {
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_0_PROPERTY,
	NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES
};
static GParamSpec* noise_plugins_audio_player_device_properties[NOISE_PLUGINS_AUDIO_PLAYER_DEVICE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _NoisePluginsAudioPlayerLibraryPrivate NoisePluginsAudioPlayerLibraryPrivate;
typedef struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData;

struct _NoisePluginsAudioPlayerDevice {
	GObject parent_instance;
	NoisePluginsAudioPlayerDevicePrivate * priv;
};

struct _NoisePluginsAudioPlayerDeviceClass {
	GObjectClass parent_class;
};

struct _NoisePluginsAudioPlayerDevicePrivate {
	GMount* mount;
	GIcon* icon;
	gboolean is_androphone;
	GeeLinkedList* music_folders;
	NoisePluginsAudioPlayerLibrary* library;
};

struct _NoisePluginsAudioPlayerLibrary {
	NoiseLibrary parent_instance;
	NoisePluginsAudioPlayerLibraryPrivate * priv;
	gint medias_rowid;
	gint playlists_rowid;
	gint smartplaylists_rowid;
	NoiseGStreamerTagger* tagger;
};

struct _NoisePluginsAudioPlayerLibraryClass {
	NoiseLibraryClass parent_class;
};

struct _NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	NoisePluginsAudioPlayerDevice* self;
	GeeLinkedList* _tmp0_;
	GMount* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GFile* file;
	GMount* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFileInputStream* _tmp18_;
	GFile* _tmp19_;
	GFileInputStream* _tmp20_;
	GDataInputStream* dis;
	GDataInputStream* _tmp21_;
	gchar* line;
	gchar* _tmp22_;
	GDataInputStream* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	gchar* folders_unparsed;
	const gchar* _tmp28_;
	gchar** _tmp29_;
	gchar** _tmp30_;
	gchar** _tmp31_;
	gint _tmp31__length1;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	const gchar* _tmp35_;
	gchar** _tmp36_;
	gchar** _tmp37_;
	gchar** folder_collection;
	gint folder_collection_length1;
	gint _folder_collection_size_;
	gint folder_it;
	gchar* _tmp38_;
	gchar* folder;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	GeeLinkedList* _tmp41_;
	GMount* _tmp42_;
	GFile* _tmp43_;
	GFile* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	GError* e;
	FILE* _tmp52_;
	GError* _tmp53_;
	const gchar* _tmp54_;
	GeeLinkedList* files;
	GeeLinkedList* _tmp55_;
	gint items;
	GeeLinkedList* _folder_list;
	GeeLinkedList* _tmp56_;
	GeeLinkedList* _tmp57_;
	gint _folder_size;
	GeeLinkedList* _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	gint _folder_index;
	gchar* _vala1_folder;
	GeeLinkedList* _tmp61_;
	gpointer _tmp62_;
	GFile* music_folder_file;
	const gchar* _tmp63_;
	GFile* _tmp64_;
	GFile* _tmp65_;
	GeeLinkedList* _tmp66_;
	NoisePluginsAudioPlayerLibrary* _tmp67_;
	NoiseGStreamerTagger* _tmp68_;
	GeeLinkedList* _tmp69_;
	GeeLinkedList* _tmp70_;
	gint _tmp71_;
	gint _tmp72_;
	NoisePluginsAudioPlayerLibrary* _tmp73_;
	GError* _inner_error0_;
};

static gint NoisePluginsAudioPlayerDevice_private_offset;
static gpointer noise_plugins_audio_player_device_parent_class = NULL;
static NoiseDeviceIface * noise_plugins_audio_player_device_noise_device_parent_iface = NULL;
static GType noise_plugins_audio_player_device_type_id = 0;

GType noise_plugins_audio_player_device_register_type (GTypeModule * module);
GType noise_plugins_audio_player_device_get_type (void) G_GNUC_CONST;
GType noise_plugins_audio_player_library_register_type (GTypeModule * module);
GType noise_plugins_audio_player_library_get_type (void) G_GNUC_CONST;
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_new (GMount* mount,
                                                                      gboolean is_androphone);
NoisePluginsAudioPlayerDevice* noise_plugins_audio_player_device_construct (GType object_type,
                                                                            GMount* mount,
                                                                            gboolean is_androphone);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_new (NoisePluginsAudioPlayerDevice* device);
NoisePluginsAudioPlayerLibrary* noise_plugins_audio_player_library_construct (GType object_type,
                                                                              NoisePluginsAudioPlayerDevice* device);
static void noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base);
static void __lambda8_ (NoisePluginsAudioPlayerDevice* self);
static void ___lambda8__noise_device_device_unmounted (NoiseDevice* _sender,
                                                gpointer self);
static void noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self,
                                                                    GAsyncReadyCallback _callback_,
                                                                    gpointer _user_data_);
static void noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self,
                                                                     GAsyncResult* _res_);
static gboolean noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base);
static void noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data);
static void noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                                        GAsyncResult *res,
                                                                                        void *user_data);
static gboolean noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_);
void noise_plugins_audio_player_library_queue_finished (NoisePluginsAudioPlayerLibrary* self);
static gboolean __lambda9_ (NoisePluginsAudioPlayerDevice* self);
static gboolean ___lambda9__gsource_func (gpointer self);
static NoiseLibrary* noise_plugins_audio_player_device_real_get_library (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_empty_device_title (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_empty_device_description (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_content_type (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_display_name (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_display_name (NoiseDevice* base,
                                                              const gchar* name);
static gchar* noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base,
                                                       GMount* mount);
static GMount* noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base,
                                                      GIcon* icon);
static GIcon* noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base);
static gchar* noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base);
static guint64 noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base);
gchar* noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self);
static guint64 noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_unmount (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_eject (NoiseDevice* base);
static void noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base);
static GtkWidget* noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base);
static gboolean noise_plugins_audio_player_device_real_read_only (NoiseDevice* base);
static void noise_plugins_audio_player_device_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
noise_plugins_audio_player_device_get_instance_private (NoisePluginsAudioPlayerDevice* self)
{
	return G_STRUCT_MEMBER_P (self, NoisePluginsAudioPlayerDevice_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self ? g_object_ref (self) : NULL;
#line 291 "AudioPlayerDevice.c"
}

NoisePluginsAudioPlayerDevice*
noise_plugins_audio_player_device_construct (GType object_type,
                                             GMount* mount,
                                             gboolean is_androphone)
{
	NoisePluginsAudioPlayerDevice * self = NULL;
	GMount* _tmp0_;
	GeeLinkedList* _tmp1_;
	NoisePluginsAudioPlayerLibrary* _tmp2_;
	NoiseLibrariesManager* _tmp3_;
	NoisePluginsAudioPlayerLibrary* _tmp4_;
	const gchar* _tmp5_ = NULL;
	GThemedIcon* _tmp6_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (mount != NULL, NULL);
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) g_object_new (object_type, NULL);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 39 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp0_;
#line 40 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = is_androphone;
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 41 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->music_folders = _tmp1_;
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = noise_plugins_audio_player_library_new (self);
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 42 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->library = _tmp2_;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = noise_libraries_manager;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = self->priv->library;
#line 43 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_libraries_manager_add_library (_tmp3_, (NoiseLibrary*) _tmp4_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (is_androphone) {
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = "phone";
#line 341 "AudioPlayerDevice.c"
	} else {
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = "music-player";
#line 345 "AudioPlayerDevice.c"
	}
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp6_ = (GThemedIcon*) g_themed_icon_new (_tmp5_);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 44 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = (GIcon*) _tmp6_;
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return self;
#line 355 "AudioPlayerDevice.c"
}

NoisePluginsAudioPlayerDevice*
noise_plugins_audio_player_device_new (GMount* mount,
                                       gboolean is_androphone)
{
#line 38 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return noise_plugins_audio_player_device_construct (NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, mount, is_androphone);
#line 364 "AudioPlayerDevice.c"
}

static void
__lambda8_ (NoisePluginsAudioPlayerDevice* self)
{
}

static void
___lambda8__noise_device_device_unmounted (NoiseDevice* _sender,
                                           gpointer self)
{
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	__lambda8_ ((NoisePluginsAudioPlayerDevice*) self);
#line 378 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_real_finish_initialization (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
#line 47 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 48 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_signal_connect_object ((NoiseDevice*) self, "device-unmounted", (GCallback) ___lambda8__noise_device_device_unmounted, self, 0);
#line 52 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_finish_initialization_async (self, NULL, NULL);
#line 391 "AudioPlayerDevice.c"
}

static gboolean
noise_plugins_audio_player_device_real_start_initialization (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 54 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = TRUE;
#line 55 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 405 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_finish_initialization_async_data_free (gpointer _data)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	_data_ = _data;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_slice_free (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData, _data_);
#line 417 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper (GObject *source_object,
                                                                                   GAsyncResult *res,
                                                                                   void *user_data)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _task_data_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_task_data_->_callback_ != NULL) {
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 432 "AudioPlayerDevice.c"
	}
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_task_data_->_task_complete_ = TRUE;
#line 436 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_finish_initialization_async (NoisePluginsAudioPlayerDevice* self,
                                                               GAsyncReadyCallback _callback_,
                                                               gpointer _user_data_)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
	NoisePluginsAudioPlayerDevice* _tmp0_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_slice_new0 (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_callback_ = _callback_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, noise_plugins_audio_player_device_finish_initialization_async_async_ready_wrapper, _user_data_);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_callback_ == NULL) {
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_task_complete_ = TRUE;
#line 456 "AudioPlayerDevice.c"
	}
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_set_task_data (_data_->_async_result, _data_, noise_plugins_audio_player_device_finish_initialization_async_data_free);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->self = _tmp0_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_finish_initialization_async_co (_data_);
#line 466 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_finish_initialization_finish (NoisePluginsAudioPlayerDevice* self,
                                                                GAsyncResult* _res_)
{
	NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 476 "AudioPlayerDevice.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 495 "AudioPlayerDevice.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 517 "AudioPlayerDevice.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 521 "AudioPlayerDevice.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 527 "AudioPlayerDevice.c"
	} else {
#line 1481 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 531 "AudioPlayerDevice.c"
	}
#line 1481 "glib-2.0.vapi"
	if (_tmp0_) {
#line 535 "AudioPlayerDevice.c"
		gchar* _tmp2_;
#line 1482 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1482 "glib-2.0.vapi"
		result = _tmp2_;
#line 1482 "glib-2.0.vapi"
		return result;
#line 543 "AudioPlayerDevice.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1485 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1485 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1485 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1485 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1485 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1485 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1485 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1485 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 571 "AudioPlayerDevice.c"
				goto __catch1_g_regex_error;
			}
#line 1485 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1485 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1485 "glib-2.0.vapi"
			return NULL;
#line 580 "AudioPlayerDevice.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1486 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1486 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1486 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 594 "AudioPlayerDevice.c"
				goto __catch1_g_regex_error;
			}
#line 1486 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1486 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1486 "glib-2.0.vapi"
			return NULL;
#line 605 "AudioPlayerDevice.c"
		}
#line 1486 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1486 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1486 "glib-2.0.vapi"
		result = _tmp10_;
#line 1486 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1486 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1486 "glib-2.0.vapi"
		return result;
#line 619 "AudioPlayerDevice.c"
	}
	goto __finally1;
	__catch1_g_regex_error:
	{
		GError* e = NULL;
#line 1484 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1484 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1488 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1484 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 633 "AudioPlayerDevice.c"
	}
	__finally1:
#line 1484 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1484 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1484 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1484 "glib-2.0.vapi"
		return NULL;
#line 644 "AudioPlayerDevice.c"
	}
}

static gboolean
__lambda9_ (NoisePluginsAudioPlayerDevice* self)
{
	gboolean result = FALSE;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 96 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 656 "AudioPlayerDevice.c"
}

static gboolean
___lambda9__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda9_ ((NoisePluginsAudioPlayerDevice*) self);
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 666 "AudioPlayerDevice.c"
}

static gboolean
noise_plugins_audio_player_device_finish_initialization_async_co (NoisePluginsAudioPlayerDeviceFinishInitializationAsyncData* _data_)
{
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	switch (_data_->_state_) {
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		case 0:
#line 676 "AudioPlayerDevice.c"
		goto _state_0;
		default:
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_assert_not_reached ();
#line 681 "AudioPlayerDevice.c"
	}
	_state_0:
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->self->priv->is_androphone) {
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp0_ = _data_->self->priv->music_folders;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp1_ = _data_->self->priv->mount;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp2_ = g_mount_get_root (_data_->_tmp1_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp4_ = g_file_get_uri (_data_->_tmp3_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp6_ = g_strconcat (_data_->_tmp5_, "/Music/", NULL);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp0_, _data_->_tmp7_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp7_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp5_);
#line 59 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp3_);
#line 710 "AudioPlayerDevice.c"
	} else {
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp8_ = _data_->self->priv->mount;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp9_ = g_mount_get_root (_data_->_tmp8_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp10_ = _data_->_tmp9_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp11_ = g_file_get_uri (_data_->_tmp10_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp13_ = g_strconcat (_data_->_tmp12_, "/.is_audio_player", NULL);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp15_ = g_file_new_for_uri (_data_->_tmp14_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp16_ = _data_->_tmp15_;
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp14_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_data_->_tmp12_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_tmp10_);
#line 62 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->file = _data_->_tmp16_;
#line 738 "AudioPlayerDevice.c"
		{
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp17_ = _data_->file;
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (g_file_query_exists (_data_->_tmp17_, NULL) == TRUE) {
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp19_ = _data_->file;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp20_ = g_file_read (_data_->_tmp19_, NULL, &_data_->_inner_error0_);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp18_ = _data_->_tmp20_;
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 752 "AudioPlayerDevice.c"
					goto __catch0_g_error;
				}
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->_tmp21_ = g_data_input_stream_new ((GInputStream*) _data_->_tmp18_);
#line 65 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_data_->dis = _data_->_tmp21_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp23_ = _data_->dis;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp24_ = g_data_input_stream_read_line (_data_->_tmp23_, NULL, NULL, &_data_->_inner_error0_);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp22_ = _data_->_tmp24_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->line);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->dis);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_data_->_tmp18_);
#line 775 "AudioPlayerDevice.c"
						goto __catch0_g_error;
					}
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp25_ = _data_->_tmp22_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp22_ = NULL;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->line);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->line = _data_->_tmp25_;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp26_ = _data_->line;
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_data_->_tmp26_ != NULL)) {
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->_tmp22_);
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 794 "AudioPlayerDevice.c"
					}
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_data_->_tmp27_ = _data_->line;
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (string_contains (_data_->_tmp27_, "audio_folders=")) {
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp28_ = _data_->line;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp30_ = _data_->_tmp29_ = g_strsplit (_data_->_tmp28_, "audio_folders=", 2);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31_ = _data_->_tmp30_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31__length1 = _vala_array_length (_data_->_tmp29_);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp32_ = _data_->_tmp31_[1];
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp33_ = g_strdup (_data_->_tmp32_);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp34_ = _data_->_tmp33_;
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp31_ = (_vala_array_free (_data_->_tmp31_, _data_->_tmp31__length1, (GDestroyNotify) g_free), NULL);
#line 70 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->folders_unparsed = _data_->_tmp34_;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp35_ = _data_->folders_unparsed;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_data_->_tmp37_ = _data_->_tmp36_ = g_strsplit (_data_->_tmp35_, ",", 0);
#line 822 "AudioPlayerDevice.c"
						{
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = 0;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->_folder_collection_size_ = 0;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = _data_->_tmp37_;
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection_length1 = _vala_array_length (_data_->_tmp36_);
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (_data_->folder_it = 0; _data_->folder_it < _vala_array_length (_data_->_tmp36_); _data_->folder_it = _data_->folder_it + 1) {
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->_tmp38_ = g_strdup (_data_->folder_collection[_data_->folder_it]);
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_data_->folder = _data_->_tmp38_;
#line 838 "AudioPlayerDevice.c"
								{
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp39_ = _data_->folder;
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp40_ = string_replace (_data_->_tmp39_, " ", "");
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 72 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->folder = _data_->_tmp40_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp41_ = _data_->self->priv->music_folders;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp42_ = _data_->self->priv->mount;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp43_ = g_mount_get_root (_data_->_tmp42_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp44_ = _data_->_tmp43_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp45_ = g_file_get_uri (_data_->_tmp44_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp46_ = _data_->_tmp45_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp47_ = g_strconcat (_data_->_tmp46_, "/", NULL);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp48_ = _data_->_tmp47_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp49_ = _data_->folder;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp50_ = g_strconcat (_data_->_tmp48_, _data_->_tmp49_, NULL);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_data_->_tmp51_ = _data_->_tmp50_;
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									gee_abstract_collection_add ((GeeAbstractCollection*) _data_->_tmp41_, _data_->_tmp51_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp51_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp48_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->_tmp46_);
#line 73 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_object_unref0 (_data_->_tmp44_);
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (_data_->folder);
#line 882 "AudioPlayerDevice.c"
								}
							}
#line 71 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							_data_->folder_collection = (_vala_array_free (_data_->folder_collection, _data_->folder_collection_length1, (GDestroyNotify) g_free), NULL);
#line 887 "AudioPlayerDevice.c"
						}
#line 69 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_data_->folders_unparsed);
#line 891 "AudioPlayerDevice.c"
					}
#line 68 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_data_->_tmp22_);
#line 895 "AudioPlayerDevice.c"
				}
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (_data_->line);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->dis);
#line 64 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_data_->_tmp18_);
#line 903 "AudioPlayerDevice.c"
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->e = _data_->_inner_error0_;
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_inner_error0_ = NULL;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp52_ = stderr;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp53_ = _data_->e;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp54_ = _data_->_tmp53_->message;
#line 79 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_data_->_tmp52_, "Error: %s\n", _data_->_tmp54_);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (_data_->e);
#line 923 "AudioPlayerDevice.c"
		}
		__finally0:
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->file);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_object_unref (_data_->_async_result);
#line 63 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return FALSE;
#line 938 "AudioPlayerDevice.c"
		}
#line 58 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->file);
#line 942 "AudioPlayerDevice.c"
	}
#line 82 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp55_ = gee_linked_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 82 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->files = _data_->_tmp55_;
#line 83 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->items = 0;
#line 950 "AudioPlayerDevice.c"
	{
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp56_ = _data_->self->priv->music_folders;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp57_ = _g_object_ref0 (_data_->_tmp56_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_list = _data_->_tmp57_;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp58_ = _data_->_folder_list;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp59_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp58_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp60_ = _data_->_tmp59_;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_size = _data_->_tmp60_;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_folder_index = -1;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (TRUE) {
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_folder_index = _data_->_folder_index + 1;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (!(_data_->_folder_index < _data_->_folder_size)) {
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				break;
#line 976 "AudioPlayerDevice.c"
			}
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp61_ = _data_->_folder_list;
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp62_ = gee_abstract_list_get ((GeeAbstractList*) _data_->_tmp61_, _data_->_folder_index);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_vala1_folder = (gchar*) _data_->_tmp62_;
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp63_ = _data_->_vala1_folder;
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp64_ = g_file_new_for_uri (_data_->_tmp63_);
#line 85 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->music_folder_file = _data_->_tmp64_;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp65_ = _data_->music_folder_file;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->_tmp66_ = _data_->files;
#line 86 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_data_->items = _data_->items + noise_file_utils_count_music_files (_data_->_tmp65_, (GeeCollection*) _data_->_tmp66_);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (_data_->music_folder_file);
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (_data_->_vala1_folder);
#line 1000 "AudioPlayerDevice.c"
		}
#line 84 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_data_->_folder_list);
#line 1004 "AudioPlayerDevice.c"
	}
#line 89 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_debug ("AudioPlayerDevice.vala:89: found %d items to import\n", _data_->items);
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp67_ = _data_->self->priv->library;
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp68_ = _data_->_tmp67_->tagger;
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp69_ = _data_->files;
#line 90 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_gstreamer_tagger_discoverer_import_media (_data_->_tmp68_, (GeeCollection*) _data_->_tmp69_);
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp70_ = _data_->files;
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp71_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _data_->_tmp70_);
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_data_->_tmp72_ = _data_->_tmp71_;
#line 91 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_tmp72_ == 0) {
#line 92 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_data_->_tmp73_ = _data_->self->priv->library;
#line 92 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		noise_plugins_audio_player_library_queue_finished (_data_->_tmp73_);
#line 1028 "AudioPlayerDevice.c"
	}
#line 94 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda9__gsource_func, g_object_ref (_data_->self), g_object_unref);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_data_->files);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (_data_->_state_ != 0) {
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		while (!_data_->_task_complete_) {
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1042 "AudioPlayerDevice.c"
		}
	}
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_object_unref (_data_->_async_result);
#line 57 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return FALSE;
#line 1049 "AudioPlayerDevice.c"
}

static NoiseLibrary*
noise_plugins_audio_player_device_real_get_library (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	NoiseLibrary* result = NULL;
	NoisePluginsAudioPlayerLibrary* _tmp0_;
	NoiseLibrary* _tmp1_;
#line 100 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->library;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 ((NoiseLibrary*) _tmp0_);
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 101 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1069 "AudioPlayerDevice.c"
}

static gchar*
noise_plugins_audio_player_device_real_get_empty_device_title (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 104 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("Empty device!"));
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 105 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1086 "AudioPlayerDevice.c"
}

static gchar*
noise_plugins_audio_player_device_real_get_empty_device_description (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 108 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_strdup (_ ("This device does not contain any music."));
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 109 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1103 "AudioPlayerDevice.c"
}

static gchar*
noise_plugins_audio_player_device_real_get_content_type (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
#line 112 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 113 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (self->priv->is_androphone) {
#line 1115 "AudioPlayerDevice.c"
		gchar* _tmp0_;
#line 114 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = g_strdup ("android");
#line 114 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp0_;
#line 114 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1123 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp1_;
#line 116 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup ("audioplayer");
#line 116 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 116 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1132 "AudioPlayerDevice.c"
	}
}

static gchar*
noise_plugins_audio_player_device_real_get_display_name (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	GError* _inner_error0_ = NULL;
#line 119 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 120 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (self->priv->is_androphone) {
#line 1146 "AudioPlayerDevice.c"
		GMount* _tmp0_;
		gchar* _tmp1_;
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = self->priv->mount;
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_mount_get_name (_tmp0_);
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 121 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1157 "AudioPlayerDevice.c"
	} else {
		GFile* file = NULL;
		GMount* _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		gchar* name = NULL;
		GMount* _tmp11_;
		gchar* _tmp12_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = self->priv->mount;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = g_mount_get_root (_tmp2_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = _tmp3_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = g_file_get_path (_tmp4_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = _tmp5_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = g_strconcat (_tmp6_, "/.is_audio_player", NULL);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp9_ = g_file_new_for_path (_tmp8_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp10_ = _tmp9_;
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp8_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp6_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp4_);
#line 123 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file = _tmp10_;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp11_ = self->priv->mount;
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp12_ = g_mount_get_name (_tmp11_);
#line 124 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		name = _tmp12_;
#line 1204 "AudioPlayerDevice.c"
		{
			GFile* _tmp13_;
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp13_ = file;
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			if (g_file_query_exists (_tmp13_, NULL) == TRUE) {
#line 1211 "AudioPlayerDevice.c"
				GFileInputStream* _tmp14_ = NULL;
				GFile* _tmp15_;
				GFileInputStream* _tmp16_;
				GDataInputStream* dis = NULL;
				GDataInputStream* _tmp17_;
				gchar* line = NULL;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp15_ = file;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp16_ = g_file_read (_tmp15_, NULL, &_inner_error0_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp14_ = _tmp16_;
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1226 "AudioPlayerDevice.c"
					goto __catch2_g_error;
				}
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_tmp17_ = g_data_input_stream_new ((GInputStream*) _tmp14_);
#line 127 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				dis = _tmp17_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				while (TRUE) {
#line 1235 "AudioPlayerDevice.c"
					gchar* _tmp18_ = NULL;
					GDataInputStream* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					const gchar* _tmp22_;
					const gchar* _tmp23_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp19_ = dis;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp20_ = g_data_input_stream_read_line (_tmp19_, NULL, NULL, &_inner_error0_);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp18_ = _tmp20_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (line);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (dis);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_object_unref0 (_tmp14_);
#line 1256 "AudioPlayerDevice.c"
						goto __catch2_g_error;
					}
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp21_ = _tmp18_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp18_ = NULL;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (line);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					line = _tmp21_;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp22_ = line;
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (!(_tmp22_ != NULL)) {
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (_tmp18_);
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						break;
#line 1275 "AudioPlayerDevice.c"
					}
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_tmp23_ = line;
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					if (string_contains (_tmp23_, "name=")) {
#line 1281 "AudioPlayerDevice.c"
						gchar* names_unparsed = NULL;
						const gchar* _tmp24_;
						gchar** _tmp25_;
						gchar** _tmp26_;
						gchar** _tmp27_;
						gint _tmp27__length1;
						const gchar* _tmp28_;
						gchar* _tmp29_;
						gchar* _tmp30_;
						const gchar* _tmp31_;
						gchar** _tmp32_;
						gchar** _tmp33_;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp24_ = line;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp26_ = _tmp25_ = g_strsplit (_tmp24_, "name=", 2);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27_ = _tmp26_;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27__length1 = _vala_array_length (_tmp25_);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp28_ = _tmp27_[1];
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp29_ = g_strdup (_tmp28_);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp30_ = _tmp29_;
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 132 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						names_unparsed = _tmp30_;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp31_ = names_unparsed;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_tmp33_ = _tmp32_ = g_strsplit (_tmp31_, "\"", 0);
#line 1316 "AudioPlayerDevice.c"
						{
							gchar** names_collection = NULL;
							gint names_collection_length1 = 0;
							gint _names_collection_size_ = 0;
							gint names_it = 0;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = _tmp33_;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection_length1 = _vala_array_length (_tmp32_);
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							for (names_it = 0; names_it < _vala_array_length (_tmp32_); names_it = names_it + 1) {
#line 1328 "AudioPlayerDevice.c"
								gchar* _tmp34_;
								gchar* names = NULL;
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								_tmp34_ = g_strdup (names_collection[names_it]);
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
								names = _tmp34_;
#line 1335 "AudioPlayerDevice.c"
								{
									gboolean _tmp35_ = FALSE;
									const gchar* _tmp36_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_tmp36_ = names;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp36_ != NULL) {
#line 1343 "AudioPlayerDevice.c"
										const gchar* _tmp37_;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp37_ = names;
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp35_ = g_strcmp0 (_tmp37_, "") != 0;
#line 1349 "AudioPlayerDevice.c"
									} else {
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp35_ = FALSE;
#line 1353 "AudioPlayerDevice.c"
									}
#line 134 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									if (_tmp35_) {
#line 1357 "AudioPlayerDevice.c"
										const gchar* _tmp38_;
										gchar* _tmp39_;
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp38_ = names;
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_tmp39_ = g_strdup (_tmp38_);
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										_g_free0 (name);
#line 135 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
										name = _tmp39_;
#line 1368 "AudioPlayerDevice.c"
									}
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
									_g_free0 (names);
#line 1372 "AudioPlayerDevice.c"
								}
							}
#line 133 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
							names_collection = (_vala_array_free (names_collection, names_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1377 "AudioPlayerDevice.c"
						}
#line 131 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
						_g_free0 (names_unparsed);
#line 1381 "AudioPlayerDevice.c"
					}
#line 130 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
					_g_free0 (_tmp18_);
#line 1385 "AudioPlayerDevice.c"
				}
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_free0 (line);
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (dis);
#line 126 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
				_g_object_unref0 (_tmp14_);
#line 1393 "AudioPlayerDevice.c"
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			FILE* _tmp40_;
			GError* _tmp41_;
			const gchar* _tmp42_;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			e = _inner_error0_;
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_inner_error0_ = NULL;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp40_ = stderr;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp41_ = e;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_tmp42_ = _tmp41_->message;
#line 141 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			fprintf (_tmp40_, "Error: %s\n", _tmp42_);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_error_free0 (e);
#line 1417 "AudioPlayerDevice.c"
		}
		__finally2:
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_free0 (name);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			_g_object_unref0 (file);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			g_clear_error (&_inner_error0_);
#line 125 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
			return NULL;
#line 1432 "AudioPlayerDevice.c"
		}
#line 143 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = name;
#line 143 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file);
#line 143 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1440 "AudioPlayerDevice.c"
	}
}

static void
noise_plugins_audio_player_device_real_set_display_name (NoiseDevice* base,
                                                         const gchar* name)
{
	NoisePluginsAudioPlayerDevice * self;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 147 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (name != NULL);
#line 1453 "AudioPlayerDevice.c"
}

static gchar*
noise_plugins_audio_player_device_real_get_fancy_description (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
#line 151 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 152 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (self->priv->is_androphone) {
#line 1465 "AudioPlayerDevice.c"
		gchar* _tmp0_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = g_strdup (_ ("Android Phone"));
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp0_;
#line 153 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1473 "AudioPlayerDevice.c"
	} else {
		gchar* _tmp1_;
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = g_strdup (_ ("Audio Player"));
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		result = _tmp1_;
#line 155 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return result;
#line 1482 "AudioPlayerDevice.c"
	}
}

static void
noise_plugins_audio_player_device_real_set_mount (NoiseDevice* base,
                                                  GMount* mount)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 159 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (mount != NULL);
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (mount);
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 160 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->mount = _tmp0_;
#line 1502 "AudioPlayerDevice.c"
}

static GMount*
noise_plugins_audio_player_device_real_get_mount (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* result = NULL;
	GMount* _tmp0_;
	GMount* _tmp1_;
#line 163 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 164 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1522 "AudioPlayerDevice.c"
}

static gchar*
noise_plugins_audio_player_device_real_get_uri (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	GMount* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 167 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = g_mount_get_default_location (_tmp0_);
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp2_ = _tmp1_;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp3_ = g_file_get_uri (_tmp2_);
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp4_ = _tmp3_;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (_tmp2_);
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp4_;
#line 168 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1553 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_real_set_icon (NoiseDevice* base,
                                                 GIcon* icon)
{
	NoisePluginsAudioPlayerDevice * self;
	GIcon* _tmp0_;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 171 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_if_fail (icon != NULL);
#line 172 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = _g_object_ref0 (icon);
#line 172 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 172 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->icon = _tmp0_;
#line 1572 "AudioPlayerDevice.c"
}

static GIcon*
noise_plugins_audio_player_device_real_get_icon (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GIcon* result = NULL;
	GIcon* _tmp0_;
	GIcon* _tmp1_;
#line 175 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->icon;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp1_;
#line 176 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1592 "AudioPlayerDevice.c"
}

static guint64
noise_plugins_audio_player_device_real_get_capacity (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
#line 179 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 180 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1606 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 183 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1635 "AudioPlayerDevice.c"
			goto __catch3_g_error;
		}
#line 184 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_SIZE);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1642 "AudioPlayerDevice.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error0_;
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error0_ = NULL;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = stdout;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = err;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_->message;
#line 186 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp6_, "Error calculating capacity of iPod: %s\n", _tmp8_);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1665 "AudioPlayerDevice.c"
	}
	__finally3:
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1670 "AudioPlayerDevice.c"
		guint64 _tmp9_ = 0ULL;
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error0_);
#line 182 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp9_;
#line 1678 "AudioPlayerDevice.c"
	}
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (guint64) rv;
#line 189 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1684 "AudioPlayerDevice.c"
}

static gchar*
noise_plugins_audio_player_device_real_get_fancy_capacity (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 192 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 193 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = g_format_size_full (noise_device_get_capacity ((NoiseDevice*) self), G_FORMAT_SIZE_DEFAULT);
#line 193 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = _tmp0_;
#line 193 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1701 "AudioPlayerDevice.c"
}

static guint64
noise_plugins_audio_player_device_real_get_used_space (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
#line 196 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 197 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = noise_device_get_capacity ((NoiseDevice*) self) - noise_device_get_free_space ((NoiseDevice*) self);
#line 197 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1715 "AudioPlayerDevice.c"
}

gchar*
noise_plugins_audio_player_device_get_music_folder (NoisePluginsAudioPlayerDevice* self)
{
	gchar* result = NULL;
	GeeLinkedList* _tmp0_;
	gpointer _tmp1_;
#line 200 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->music_folders;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp1_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, 0);
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = (gchar*) _tmp1_;
#line 201 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1734 "AudioPlayerDevice.c"
}

static guint64
noise_plugins_audio_player_device_real_get_free_space (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	guint64 result = 0ULL;
	guint64 rv = 0ULL;
	GError* _inner_error0_ = NULL;
#line 204 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 205 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	rv = (guint64) 0;
#line 1748 "AudioPlayerDevice.c"
	{
		GFileInfo* file_info = NULL;
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileInfo* _tmp4_;
		GFileInfo* _tmp5_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp0_ = noise_device_get_uri ((NoiseDevice*) self);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = _tmp0_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_file_query_filesystem_info (_tmp3_, "filesystem::*", NULL, &_inner_error0_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_free0 (_tmp1_);
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		file_info = _tmp5_;
#line 208 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1777 "AudioPlayerDevice.c"
			goto __catch4_g_error;
		}
#line 209 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		rv = g_file_info_get_attribute_uint64 (file_info, G_FILE_ATTRIBUTE_FILESYSTEM_FREE);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (file_info);
#line 1784 "AudioPlayerDevice.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* err = NULL;
		FILE* _tmp6_;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		err = _inner_error0_;
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_inner_error0_ = NULL;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp6_ = stdout;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp7_ = err;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp8_ = _tmp7_->message;
#line 211 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		fprintf (_tmp6_, "Error calculating free space on iPod: %s\n", _tmp8_);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_error_free0 (err);
#line 1807 "AudioPlayerDevice.c"
	}
	__finally4:
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1812 "AudioPlayerDevice.c"
		guint64 _tmp9_ = 0ULL;
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_clear_error (&_inner_error0_);
#line 207 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		return _tmp9_;
#line 1820 "AudioPlayerDevice.c"
	}
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = rv;
#line 214 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1826 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_real_unmount (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 217 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 218 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 218 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_mount_unmount_with_operation (_tmp0_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 1840 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_real_eject (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GMount* _tmp0_;
#line 221 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 222 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_tmp0_ = self->priv->mount;
#line 222 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	if (g_mount_can_eject (_tmp0_)) {
#line 1854 "AudioPlayerDevice.c"
		GMount* _tmp1_;
		GVolume* _tmp2_;
		GVolume* _tmp3_;
		GDrive* _tmp4_;
		GDrive* _tmp5_;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp1_ = self->priv->mount;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp2_ = g_mount_get_volume (_tmp1_);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp3_ = _tmp2_;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp4_ = g_volume_get_drive (_tmp3_);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_tmp5_ = _tmp4_;
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		g_drive_eject_with_operation (_tmp5_, G_MOUNT_UNMOUNT_NONE, NULL, NULL, NULL, NULL);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp5_);
#line 223 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
		_g_object_unref0 (_tmp3_);
#line 1876 "AudioPlayerDevice.c"
	}
}

static void
noise_plugins_audio_player_device_real_synchronize (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
#line 227 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 1886 "AudioPlayerDevice.c"
}

static gboolean
noise_plugins_audio_player_device_real_only_use_custom_view (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 231 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 232 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 232 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1900 "AudioPlayerDevice.c"
}

static GtkWidget*
noise_plugins_audio_player_device_real_get_custom_view (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	GtkWidget* result = NULL;
#line 235 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 236 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = NULL;
#line 236 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1914 "AudioPlayerDevice.c"
}

static gboolean
noise_plugins_audio_player_device_real_read_only (NoiseDevice* base)
{
	NoisePluginsAudioPlayerDevice * self;
	gboolean result = FALSE;
#line 239 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = (NoisePluginsAudioPlayerDevice*) base;
#line 240 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	result = FALSE;
#line 240 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	return result;
#line 1928 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_class_init (NoisePluginsAudioPlayerDeviceClass * klass,
                                              gpointer klass_data)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_parent_class = g_type_class_peek_parent (klass);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	g_type_class_adjust_private_offset (klass, &NoisePluginsAudioPlayerDevice_private_offset);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_plugins_audio_player_device_finalize;
#line 1941 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_noise_device_interface_init (NoiseDeviceIface * iface,
                                                               gpointer iface_data)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	noise_plugins_audio_player_device_noise_device_parent_iface = g_type_interface_peek_parent (iface);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->finish_initialization = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_finish_initialization;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->start_initialization = (gboolean (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_start_initialization;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_library = (NoiseLibrary* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_library;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_empty_device_title = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_empty_device_title;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_empty_device_description = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_empty_device_description;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_content_type = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_content_type;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_display_name = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_display_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_display_name = (void (*) (NoiseDevice*, const gchar*)) noise_plugins_audio_player_device_real_set_display_name;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_description = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_fancy_description;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_mount = (void (*) (NoiseDevice*, GMount*)) noise_plugins_audio_player_device_real_set_mount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_mount = (GMount* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_mount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_uri = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_uri;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->set_icon = (void (*) (NoiseDevice*, GIcon*)) noise_plugins_audio_player_device_real_set_icon;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_icon = (GIcon* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_icon;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_capacity = (guint64 (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_capacity;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_fancy_capacity = (gchar* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_fancy_capacity;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_used_space = (guint64 (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_used_space;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_free_space = (guint64 (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_free_space;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->unmount = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_unmount;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->eject = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_eject;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->synchronize = (void (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_synchronize;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->only_use_custom_view = (gboolean (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_only_use_custom_view;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->get_custom_view = (GtkWidget* (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_get_custom_view;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	iface->read_only = (gboolean (*) (NoiseDevice*)) noise_plugins_audio_player_device_real_read_only;
#line 1998 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_instance_init (NoisePluginsAudioPlayerDevice * self,
                                                 gpointer klass)
{
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv = noise_plugins_audio_player_device_get_instance_private (self);
#line 33 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self->priv->is_androphone = FALSE;
#line 2009 "AudioPlayerDevice.c"
}

static void
noise_plugins_audio_player_device_finalize (GObject * obj)
{
	NoisePluginsAudioPlayerDevice * self;
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_PLUGINS_TYPE_AUDIO_PLAYER_DEVICE, NoisePluginsAudioPlayerDevice);
#line 31 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->mount);
#line 32 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->icon);
#line 34 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->music_folders);
#line 36 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	_g_object_unref0 (self->priv->library);
#line 29 "../plugins/Devices/AudioPlayers/AudioPlayerDevice.vala"
	G_OBJECT_CLASS (noise_plugins_audio_player_device_parent_class)->finalize (obj);
#line 2028 "AudioPlayerDevice.c"
}

GType
noise_plugins_audio_player_device_get_type (void)
{
	return noise_plugins_audio_player_device_type_id;
}

GType
noise_plugins_audio_player_device_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (NoisePluginsAudioPlayerDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_plugins_audio_player_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoisePluginsAudioPlayerDevice), 0, (GInstanceInitFunc) noise_plugins_audio_player_device_instance_init, NULL };
	static const GInterfaceInfo noise_device_info = { (GInterfaceInitFunc) noise_plugins_audio_player_device_noise_device_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	noise_plugins_audio_player_device_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "NoisePluginsAudioPlayerDevice", &g_define_type_info, 0);
	g_type_module_add_interface (module, noise_plugins_audio_player_device_type_id, NOISE_TYPE_DEVICE, &noise_device_info);
	NoisePluginsAudioPlayerDevice_private_offset = sizeof (NoisePluginsAudioPlayerDevicePrivate);
	return noise_plugins_audio_player_device_type_id;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

